package de.ubt.wm.sb.junit;
import static org.junit.Assert.*;

import java.util.HashSet;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.BallProperty;
import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.HitTechnique;
import de.ubt.wm.sb.model.Move;
import de.ubt.wm.sb.model.PlayerAction;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;
import de.ubt.wm.sb.model.strategy.Strategy;
import de.ubt.wm.sb.sim.MainSim;

public class ActionSetsEquiv {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void test() {
		Game game = Game.getInstance();
		game.initGame("Germany", "Brink", "Reckerman", MainSim.skillDataFiles[0][0], MainSim.skillDataFiles[0][1], Strategy.cali_allMatchesExceptFinal_TeamA_read,
				"Brasilien", "Alison", "Emanuel", MainSim.skillDataFiles[0][2], MainSim.skillDataFiles[0][3], Strategy.cali_allMatchesExceptFinal_TeamB_read);
		
		game.setCurrentState(de.ubt.wm.sb.model.State.Start_State_A1_A02);
		HashSet<de.ubt.wm.sb.model.Move> moves;
		try {
			moves = game.getTeamA().getPlayer1().getAvailableMoves();
			HashSet<de.ubt.wm.sb.model.Move> moves2;
			moves2 = game.getTeamA().getPlayer1().getAvailableMoves();
			assertTrue("Start state allowed moves PlayerA1", moves.containsAll(moves2));
			
			game.setCurrentState(de.ubt.wm.sb.model.State.Start_State_A1_A02);
			HashSet<de.ubt.wm.sb.model.Hit> hits = game.getTeamA().getPlayer1().getAvailableHits();
			HashSet<de.ubt.wm.sb.model.Hit> hits2 = game.getTeamA().getPlayer1().getAvailableHits();
			assertTrue("Start state allowed hits PlayerA1", hits.containsAll(hits2));
			
			game.setCurrentState(de.ubt.wm.sb.model.State.Start_State_A1_A02);
			HashSet<de.ubt.wm.sb.model.PlayerAction> pactions = game.getTeamA().getPlayer1().getPlayerActions();
			HashSet<de.ubt.wm.sb.model.PlayerAction> pactions2 = game.getTeamA().getPlayer1().getPlayerActions();
			assertTrue("Start state allowed player actions PlayerA1", pactions.containsAll(pactions2));	
		} catch (Exception e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		
		

		
		PlayerAction pA1 = new PlayerAction(Hit.nohit, Move.M_f);
		PlayerAction pA2 = new PlayerAction(Hit.nohit, Move.M_f);
		assertTrue("same player actions: ", pA1.equals(pA2));
		
		PlayerAction pA = new PlayerAction(Hit.nohit, Move.m_l);
		TeamAction tA1 = new TeamAction(pA,pA,null);
		TeamAction tA2 = new TeamAction(pA,pA,null);
		assertTrue("identical team actions", tA1.equals(tA2));
		TeamAction tA3 = new TeamAction(pA,pA,game.getTeamA().getPlayer2());
		assertTrue("different team actions", !tA1.equals(tA3));
		
		game.setCurrentState(de.ubt.wm.sb.model.State.Start_State_A1_A02);
		HashSet<de.ubt.wm.sb.model.TeamAction> actions;
		try {
			actions = game.getTeamA().getAllowedTeamActions();
			HashSet<de.ubt.wm.sb.model.TeamAction> actions2 = game.getTeamA().getAllowedTeamActions();
			assertTrue("Start state allowed team actions Team A", actions.containsAll(actions2));

		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		game.setCurrentState(new State(Field.A02, Field.A13, Field.B12, Field.B13, Field.B12, game.getTeamA().getPlayer1(), -1, game.getTeamA().getPlayer1(), BallProperty.NORMAL,null));
		try {
			HashSet<TeamAction> tATeamB = game.getTeamB().getAllowedTeamActions();
			assertTrue("Hit was build:",tATeamB.contains(new TeamAction(new PlayerAction(new Hit(HitTechnique.r, Field.B23), Move.stay), new PlayerAction(Hit.nohit, Move.m_f), null)));
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
