package de.ubt.wm.sb.junit;

import static org.junit.Assert.*;

import java.util.HashSet;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.BallProperty;
import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.Move;
import de.ubt.wm.sb.model.PlayerAction;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;
import de.ubt.wm.sb.model.strategy.Strategy;
import de.ubt.wm.sb.sim.MainSim;

public class AllowedActionSet {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void choosenActionIsAllowed() {
		Game game = Game.getInstance();
		game.initGame("Germany", "Brink", "Reckerman", MainSim.skillDataFiles[0][0], MainSim.skillDataFiles[0][1], Strategy.BasicTeamA,
				"Brasilien", "Alison", "Emanuel", MainSim.skillDataFiles[0][2], MainSim.skillDataFiles[0][3], Strategy.BasicTeamB);
		
		HashSet<TeamAction> testSet = new HashSet<TeamAction>();
		TeamAction testAct = new TeamAction(new PlayerAction(Hit.nohit, Move.m_f), new PlayerAction(Hit.nohit, Move.m_f));
		testSet.add(testAct);
		assertTrue("tA included in testSet: ", testSet.contains(new TeamAction(new PlayerAction(Hit.nohit, Move.m_f), new PlayerAction(Hit.nohit, Move.m_f))));

		testAct.setActionPlayer1(new PlayerAction(Hit.nohit, Move.m_b));
		testAct.setActionPlayer1(new PlayerAction(Hit.nohit, Move.m_f));
		game.setCurrentState(new State(Field.A02, Field.A13, Field.B12, Field.B13, Field.B12, game.getTeamA().getPlayer1(), -1, game.getTeamA().getPlayer1(), BallProperty.NORMAL, null));
		try {
			assertTrue("state " + game.getCurrentState().toString() + " contains " + testAct, game.getTeamA().getAllowedTeamActions().contains(testAct));
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		
		for (int i = 0; i<100; i++){
			while (!State.POINT_A.contains(game.getCurrentState()) 
					&& !State.POINT_B.contains(game.getCurrentState())){
				
				game.chooseTeamActions();
				TeamAction tA;
				try {
					tA = game.getTeamA().getTeamAction();
					assertTrue("chosen Action is in AllowedAction Set " + game.getCurrentState().toString() + " " + tA.toString(), game.getTeamA().getAllowedTeamActions().contains(tA));
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				try {
					game.computeNextState();
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}// end rally
			
			game.setCurrentState(game.getRandomServingState());
		}
	}
	
	@Test
	public void chosenActionIsAllowed2(){
		Game game = Game.getInstance();
		game.initGame("Germany", "Brink", "Reckerman", MainSim.skillDataFiles[0][0], MainSim.skillDataFiles[0][1], Strategy.BasicTeamA,
				"Brasilien", "Alison", "Emanuel", MainSim.skillDataFiles[0][2], MainSim.skillDataFiles[0][3], Strategy.BasicTeamB);
		
		game.setCurrentState(new State(Field.A12, Field.A23, Field.B23, Field.B23, Field.B23, game.getTeamA().getPlayer1(), 1, game.getTeamB().getPlayer1(), BallProperty.NORMAL, game.getTeamA().getPlayer1()));
		TeamAction ta = new TeamAction(new PlayerAction(Hit.nohit, Move.m_f), new PlayerAction(Hit.nohit, Move.stay));
		try {
			assertTrue(game.getTeamA().getAllowedTeamActions().contains(ta));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
