package de.ubt.wm.sb.junit;

import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;
import de.ubt.wm.sb.model.strategy.Strategy;

public class AllowedTeamActionInAllowedActionSet {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		Game game = Game.getInstance();
		game.initGame("Germany", "Brink", "Reckerman","data/allMatches/GER_Brink_InputData_allMatches.xls","data/allMatches/GER_Reckermann_InputData_allMatches.xls", Strategy.BasicTeamA,
		"France", "Alison", "Emanuel", "data/allMatches/BRA_Alison_InputData_allMatches.xls","data/allMatches/BRA_Emanuel_InputData_allMatches.xls", Strategy.BasicTeamB);
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void chosenActionIsInAllowedActionSet() {
		Game game = Game.getInstance();
		for (int i = 0; i<100; i++){
			while (!State.POINT_A.contains(game.getCurrentState()) 
					&& !State.POINT_B.contains(game.getCurrentState())){
				
				game.chooseTeamActions();
				TeamAction tA;
				try {
					tA = game.getTeamA().getTeamAction();
					assertTrue("chosen Action is in AllowedAction Set " + game.getCurrentState().toString() + " " + tA.toString(), game.getTeamA().getAllowedTeamActions().contains(tA));
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				try {
					game.computeNextState();
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}// end rally
			
			game.setCurrentState(game.getRandomServingState());
		}
	}


}
