package de.ubt.wm.sb.junit;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.BallProperty;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.strategy.Strategy;
import de.ubt.wm.sb.sim.MainSim;
import de.ubt.wm.sb.model.State;

public class HashingStates {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void twoStatesAreEqual() {
		Game game = Game.getInstance();
		game.initGame("Germany", "Brink", "Reckerman", MainSim.skillDataFiles[0][0], MainSim.skillDataFiles[0][1], Strategy.cali_allMatchesExceptFinal_TeamA_read,
				"Brasilien", "Alison", "Emanuel", MainSim.skillDataFiles[0][2], MainSim.skillDataFiles[0][3], Strategy.cali_allMatchesExceptFinal_TeamB_read);
	
		
		State s1 = new de.ubt.wm.sb.model.State(de.ubt.wm.sb.model.Field.A12, de.ubt.wm.sb.model.Field.A13, de.ubt.wm.sb.model.Field.B11,de.ubt.wm.sb.model.Field.B22, de.ubt.wm.sb.model.Field.A23, game.getTeamA().getPlayer1(),
				1, game.getTeamB().getPlayer1(),BallProperty.NORMAL, game.getTeamA().getPlayer2());
		State s2 = new de.ubt.wm.sb.model.State(de.ubt.wm.sb.model.Field.A12, de.ubt.wm.sb.model.Field.A13, de.ubt.wm.sb.model.Field.B11,de.ubt.wm.sb.model.Field.B22, de.ubt.wm.sb.model.Field.A23, game.getTeamA().getPlayer1(),
				1, game.getTeamB().getPlayer1(),BallProperty.NORMAL, game.getTeamA().getPlayer2());
		assertEquals("states should have same hashCode", s1.hashCode(), s2.hashCode()); 
	}
	
	@Test
	public void PointState() {
		Game game = Game.getInstance();
		game.initGame("Germany", "Brink", "Reckerman", MainSim.skillDataFiles[0][0], MainSim.skillDataFiles[0][1], Strategy.cali_allMatchesExceptFinal_TeamA_read,
				"Brasilien", "Alison", "Emanuel", MainSim.skillDataFiles[0][2], MainSim.skillDataFiles[0][3], Strategy.cali_allMatchesExceptFinal_TeamB_read);
	
		
		assertTrue("Point for A should be contained", State.POINT_A.contains(State.POINT_A_A2));
		assertTrue("Point for A should be contained", State.POINT_A.contains(State.POINT_A_A1));
		assertFalse("Point for B should not be contained", State.POINT_A.contains(State.POINT_B_A2));
		assertFalse("Point for B should not be contained", State.POINT_A.contains(State.POINT_B_A1));
		
	}

}
