package de.ubt.wm.sb.junit;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.BallProperty;
import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.strategy.Strategy;

public class IsServerInServingPositionTest {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		Game game = Game.getInstance();
		game.initGame("Germany", "Brink", "Reckerman","data/allMatches/GER_Brink_InputData_allMatches.xls","data/allMatches/GER_Reckermann_InputData_allMatches.xls", Strategy.BasicTeamA,
		"France", "Alison", "Emanuel", "data/allMatches/BRA_Alison_InputData_allMatches.xls","data/allMatches/BRA_Emanuel_InputData_allMatches.xls", Strategy.BasicTeamB);
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void test() {
		Game game = Game.getInstance();
		State start_state = new State(Field.A02, Field.A13, Field.B12, Field.B13, Field.A02, Game.getInstance().getTeamA().getPlayer1(), -1, null, BallProperty.NORMAL, null);
		State.START_STATES_A1 = new State[]{start_state};
	
		game.setCurrentState(start_state);
		assertTrue("Spieler A1 Server in Serving Position", game.getTeamA().getPlayer1().isServerInItsServingState());
		assertFalse("Spieler A2 not in Serving Position", game.getTeamA().getPlayer2().isServerInItsServingState());
	}

}
