package de.ubt.wm.sb.junit;

import static org.junit.Assert.*;

import java.io.File;
import java.io.IOException;

import org.junit.Before;
import org.junit.Test;

import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.strategy.Strategy;
import jxl.NumberCell;
import jxl.Sheet;
import jxl.Workbook;
import jxl.read.biff.BiffException;

public class ReadProbabilities {

	@Before
	public void setUp() throws Exception {
		Game game = Game.getInstance();
		game.initGame("Germany", "Brink", "Reckerman","data/allMatches/GER_Brink_InputData_allMatches.xls","data/allMatches/GER_Reckermann_InputData_allMatches.xls", Strategy.BasicTeamA,
		"France", "Alison", "Emanuel", "data/allMatches/BRA_Alison_InputData_allMatches.xls","data/allMatches/BRA_Emanuel_InputData_allMatches.xls", Strategy.BasicTeamB);
	}

	
	@Test
	public void testExampleProb() {
		Game game = Game.getInstance();
		double prob = game.getTeamA().getPlayer1().getIndProbs().getProbBlock().getDirectPointProb();
		
		double prob_new = -1;
		// Einleseroutine angepasst auf Excel Sheet PaperInputData_allMatches.xls		
		Workbook workbook;
		try {
			workbook = Workbook.getWorkbook(new File("data/allMatches/GER_Brink_InputData_allMatches.xls"));
			// es werden original Probs eingelesen, die Modifikationen werden im Java Programm berechnet
			Sheet sheet = workbook.getSheet(2);
			// Blocking Player Value
			NumberCell cellIsBlockPlayer = (NumberCell) sheet.getCell("G40");
			prob_new = cellIsBlockPlayer.getValue();
		} catch (BiffException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
				
		assertTrue("should be same Prob-Value", prob_new == prob);
	}

}
