package de.ubt.wm.sb.junit;

import static org.junit.Assert.*;

import java.util.Arrays;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.strategy.Strategy;
import de.ubt.wm.sb.sim.MainSim;

public class deviationToOutsideField {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		MainSim.M1_devToOutsideFieldOnlyForServesAndAttacks = true;
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void riskyStrategyIfDeviationThenAlwaysOutsideField() {
		Game.getInstance().initGame("Germany", "Brink", "Reckerman","data/allMatches/GER_Brink_InputData_allMatches.xls","data/allMatches/GER_Reckermann_InputData_allMatches.xls", Strategy.RiskyTeamA,
				"Brasilien", "Alison", "Emanuel", "data/allMatches/BRA_Alison_InputData_allMatches.xls","data/allMatches/BRA_Emanuel_InputData_allMatches.xls", Strategy.cali_finalMatch_TeamB_read);

		for (int i = 0; i < 100; i++){
			Game.getInstance().setCurrentState(State.getRandomStartStateA());
			
			Game.getInstance().chooseTeamActions();
			Field targetField;
			if (Game.getInstance().getTeamA().getPlayer1().getPlayerAction().getHit() != Hit.nohit)
				targetField = Game.getInstance().getTeamA().getPlayer1().getPlayerAction().getHit().getTargetField();
			else{
				targetField = Game.getInstance().getTeamA().getPlayer2().getPlayerAction().getHit().getTargetField();
			}
			try {
				Game.getInstance().computeNextState();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			if (!State.POINT_A.contains(Game.getInstance().getCurrentState()) 
					&& !State.POINT_B.contains(Game.getInstance().getCurrentState())){
				if (! (Game.getInstance().getCurrentState().getFieldBall() == targetField)){
					System.out.println(Game.getInstance().getCurrentState().getFieldBall());
					assertTrue("Wenn Abweichung, dann Outsidefield",
							Arrays.asList(Field.OUT_A).contains(Game.getInstance().getCurrentState().getFieldBall()) 
							|| Arrays.asList(Field.OUT_B).contains(Game.getInstance().getCurrentState().getFieldBall()));
				}
			}
		}
		
		
	}
	
	@Test
	public void safeStrategyNormalDeviationNoOutsideField() {
		Game.getInstance().initGame("Germany", "Brink", "Reckerman","data/allMatches/GER_Brink_InputData_allMatches.xls","data/allMatches/GER_Reckermann_InputData_allMatches.xls", Strategy.SafeTeamA,
				"Brasilien", "Alison", "Emanuel", "data/allMatches/BRA_Alison_InputData_allMatches.xls","data/allMatches/BRA_Emanuel_InputData_allMatches.xls", Strategy.cali_finalMatch_TeamB_read);

		for (int i = 0; i < 100; i++){
			Game.getInstance().setCurrentState(State.getRandomStartStateA());
			
			Game.getInstance().chooseTeamActions();
			Field targetField;
			if (Game.getInstance().getTeamA().getPlayer1().getPlayerAction().getHit() != Hit.nohit)
				targetField = Game.getInstance().getTeamA().getPlayer1().getPlayerAction().getHit().getTargetField();
			else{
				targetField = Game.getInstance().getTeamA().getPlayer2().getPlayerAction().getHit().getTargetField();
			}
			try {
				Game.getInstance().computeNextState();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			if (!State.POINT_A.contains(Game.getInstance().getCurrentState()) 
					&& !State.POINT_B.contains(Game.getInstance().getCurrentState())){
				if (! (Game.getInstance().getCurrentState().getFieldBall() == targetField)){
					System.out.println(Game.getInstance().getCurrentState().getFieldBall());
					assertTrue("Wenn Abweichung, dann Outsidefield",
							!Arrays.asList(Field.OUT_A).contains(Game.getInstance().getCurrentState().getFieldBall()) 
							|| !Arrays.asList(Field.OUT_B).contains(Game.getInstance().getCurrentState().getFieldBall()));
				}
			}
		}
		
		
	}

}
