package de.ubt.wm.sb.junit.probs;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.strategy.Strategy;
import de.ubt.wm.sb.sim.MainSim;
import de.ubt.wm.sb.sim.SimulationManager;

public class EstimatedProbTest {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		Game.getInstance().initGame("Germany", "Brink", "Reckerman","data/allMatches/GER_Brink_InputData_allMatches.xls","data/allMatches/GER_Reckermann_InputData_allMatches.xls", Strategy.cali_finalMatch_TeamA,
				"Brasilien", "Alison", "Emanuel", "data/allMatches/BRA_Alison_InputData_allMatches.xls","data/allMatches/BRA_Emanuel_InputData_allMatches.xls", Strategy.cali_finalMatch_TeamB);
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void test() {
		Game g = Game.getInstance();
		
		System.out.println("Expected Service fault A1: " + g.getTeamA().getPlayer1().calculateExpectedServiceFault());
		System.out.println("Expected Service fault A2: " + g.getTeamA().getPlayer2().calculateExpectedServiceFault());
		
		System.out.println("Expected Service succ B1: " + g.getTeamB().getPlayer1().calculateExpectedServiceSucc());
		System.out.println("Expected Service dev B2: " + g.getTeamB().getPlayer2().calculateExpectedServiceDev());
		
//		System.out.println("Max servie Succ A1: " + Arrays.toString(g.getTeamA().getPlayer1().getMinMaxSuccFaultDev(true, 
//				new HashSet<HitTechnique>(Arrays.asList(HitTechnique.S_F, HitTechnique.S_J)))));
//		
		
		SimulationManager simManager = MainSim.startSim(1000, null);
		simManager.computeSummary();
		simManager.getServeP();
		
		System.out.println("untere Schranke POverline^serve kalibrierte Strategie, pO^serve is " 
				+ simManager.getServePOverline()
				+ "should >= than " + Math.min(g.getTeamA().getPlayer1().calculateExpectedServiceFault(), g.getTeamA().getPlayer2().calculateExpectedServiceFault()));
		
		assertTrue("untere Schranke POverline^serve kalibrierte Strategie, pO^serve is " 
				+ simManager.getServePOverline()
				+ "should >= than " + Math.min(g.getTeamA().getPlayer1().calculateExpectedServiceFault(), g.getTeamA().getPlayer2().calculateExpectedServiceFault()), 
				simManager.getServePOverline() >= Math.min(g.getTeamA().getPlayer1().calculateExpectedServiceFault(), g.getTeamA().getPlayer2().calculateExpectedServiceFault()));
	
		System.out.println("untere Schranke QOverline^serve kalibrierte Strategie, qO^serve is " 
				+ simManager.getServeQOverline()
				+ "should >= than " + Math.min(g.getTeamB().getPlayer1().calculateExpectedServiceFault(), g.getTeamB().getPlayer2().calculateExpectedServiceFault()));
		
		assertTrue("untere Schranke QOverline^serve kalibrierte Strategie, qO^serve is " 
				+ simManager.getServeQOverline()
				+ "should >= than " + Math.min(g.getTeamB().getPlayer1().calculateExpectedServiceFault(), g.getTeamB().getPlayer2().calculateExpectedServiceFault()), 
				simManager.getServeQOverline() >= Math.min(g.getTeamB().getPlayer1().calculateExpectedServiceFault(), g.getTeamB().getPlayer2().calculateExpectedServiceFault()));
		
		System.out.println("Expected Service fault A1: " + g.getTeamA().getPlayer1().calculateExpectedServiceFault());
		System.out.println("Expected Service fault A2: " + g.getTeamA().getPlayer2().calculateExpectedServiceFault());		
		System.out.println("Expected Service dev A1: " + g.getTeamA().getPlayer1().calculateExpectedServiceDev());
		System.out.println("Expected Service dev A2: " + g.getTeamA().getPlayer2().calculateExpectedServiceDev());
		System.out.println("obere Schranke POverline^serve kalibrierte Strategie, pO^serve is " 
				+ simManager.getServePOverline()
				+ " should <= than " + (Math.max(g.getTeamA().getPlayer1().calculateExpectedServiceFault(), g.getTeamA().getPlayer2().calculateExpectedServiceFault())
				+ Math.max(g.getTeamA().getPlayer1().calculateExpectedServiceDev(), g.getTeamA().getPlayer2().calculateExpectedServiceDev())));
		
		assertTrue("obere Schranke POverline^serve kalibrierte Strategie, pO^serve is " 
				+ simManager.getServePOverline()
				+ "should <= than " + Math.max(g.getTeamA().getPlayer1().calculateExpectedServiceFault(), g.getTeamA().getPlayer2().calculateExpectedServiceFault())
				+ Math.max(g.getTeamA().getPlayer1().calculateExpectedServiceDev(), g.getTeamA().getPlayer2().calculateExpectedServiceDev()), 
				simManager.getServePOverline() <= Math.max(g.getTeamA().getPlayer1().calculateExpectedServiceFault(), g.getTeamA().getPlayer2().calculateExpectedServiceFault())
				+ Math.max(g.getTeamA().getPlayer1().calculateExpectedServiceDev(), g.getTeamA().getPlayer2().calculateExpectedServiceDev()));
		
		System.out.println("obere Schranke QOverline^serve kalibrierte Strategie, QO^serve is " 
				+ simManager.getServeQOverline()
				+ "should <= than " + (Math.max(g.getTeamB().getPlayer1().calculateExpectedServiceFault(), g.getTeamB().getPlayer2().calculateExpectedServiceFault())
				+ Math.max(g.getTeamB().getPlayer1().calculateExpectedServiceDev(), g.getTeamB().getPlayer2().calculateExpectedServiceDev())));
		
		assertTrue("obere Schranke QOverline^serve kalibrierte Strategie, QO^serve is " 
				+ simManager.getServeQOverline()
				+ "should <= than " + (Math.max(g.getTeamB().getPlayer1().calculateExpectedServiceFault(), g.getTeamB().getPlayer2().calculateExpectedServiceFault())
				+ Math.max(g.getTeamB().getPlayer1().calculateExpectedServiceDev(), g.getTeamB().getPlayer2().calculateExpectedServiceDev())), 
				simManager.getServeQOverline() <= Math.max(g.getTeamB().getPlayer1().calculateExpectedServiceFault(), g.getTeamB().getPlayer2().calculateExpectedServiceFault())
				+ Math.max(g.getTeamB().getPlayer1().calculateExpectedServiceDev(), g.getTeamB().getPlayer2().calculateExpectedServiceDev()));
		
	
	}

}
