package de.ubt.wm.sb.junit.sim;

import static org.junit.Assert.assertTrue;

import java.util.Arrays;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.HitTechnique;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.strategy.Strategy;

public class CalibrationStratTest {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
				
		Game.getInstance().initGame("Germany", "Brink", "Reckerman","data/allMatches/GER_Brink_InputData_allMatches.xls","data/allMatches/GER_Reckermann_InputData_allMatches.xls", Strategy.RiskyTeamA,
				"Brasilien", "Alison", "Emanuel", "data/allMatches/BRA_Alison_InputData_allMatches.xls","data/allMatches/BRA_Emanuel_InputData_allMatches.xls", Strategy.cali_finalMatch_TeamB_read);
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testRiskyPreferences() {
		Game g = Game.getInstance();
		
		for (int i = 0; i < 50; i++){
			g.setCurrentState(State.chooseRandomStateOfArray(State.START_STATES_A1));
			g.chooseTeamActions();
			
			try {
				assertTrue("Spieler A1 benutzt nur SJ, Hit is " + g.getTeamA().getTeamAction().getActionPlayer1().toString(), 
						g.getTeamA().getTeamAction().getActionPlayer1().getHit().getTechnique() == HitTechnique.S_J);
				assertTrue("Spieler A1 benutzt nur Randfeld", 
						Arrays.asList(Field.BORDER_B).contains(g.getTeamA().getTeamAction().getActionPlayer1().getHit().getTargetField()));
			
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
		
	}

}
