package de.ubt.wm.sb.junit.sim;

import static org.junit.Assert.*;

import java.util.HashMap;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.BallProperty;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.HitTechnique;
import de.ubt.wm.sb.model.strategy.Strategy;
import de.ubt.wm.sb.probs.Prob_Hit;
import de.ubt.wm.sb.sim.MainSim;
import de.ubt.wm.sb.sim.SimulationManager;

public class ResetStateTest {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		Game.getInstance().initGame("Germany", "Brink", "Reckerman","data/allMatches/GER_Brink_InputData_allMatches.xls","data/allMatches/GER_Reckermann_InputData_allMatches.xls", Strategy.BasicTeamA,
				"Brasilien", "Alison", "Emanuel", "data/allMatches/BRA_Alison_InputData_allMatches.xls","data/allMatches/BRA_Emanuel_InputData_allMatches.xls", Strategy.BasicTeamB);
		
		Game g = Game.getInstance();
		
		// alle Annahme Wahrscheinlichkeiten Löschen
		g.getTeamA().getPlayer1().getIndProbs().setReceivingProbs(new HashMap<HitTechnique, HashMap<BallProperty, Prob_Hit>>());
		g.getTeamA().getPlayer2().getIndProbs().setReceivingProbs(new HashMap<HitTechnique, HashMap<BallProperty, Prob_Hit>>());
		g.getTeamB().getPlayer1().getIndProbs().setReceivingProbs(new HashMap<HitTechnique, HashMap<BallProperty, Prob_Hit>>());
		g.getTeamB().getPlayer2().getIndProbs().setReceivingProbs(new HashMap<HitTechnique, HashMap<BallProperty, Prob_Hit>>());
		
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void test() {
		// Achtung wenn Anzahl der Saetze zu gering, kann es dazu führen, dass max numerb of Resets nicht erreicht wird
		// da zu oft Fehler beim Aufschlag gemacht werden, oder keiner den Ball annimmt 
		SimulationManager simManager = MainSim.startSim(100,  true, 0, true, null, "allMatchesSkills");
		
		assertTrue("Alle Aufschlaege sind zurückgesetzt worden 100 Satze, numberOfResets is " + simManager.numberOfResets,
				simManager.numberOfResets == SimulationManager.maxNumberOfResets+1);
	}

}
