package de.ubt.wm.sb.gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JToggleButton;
import javax.swing.SwingConstants;

import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.Move;
import de.ubt.wm.sb.model.Player;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.Team;

public class ViewSimFrame extends JFrame {

	private static final long serialVersionUID = 7629166900198352396L;
	
	private DrawingPanel drawingPanel;
	private JLabel lbl_currentstate;
	private JLabel txt_pointsTeamA;
	private JLabel txt_pointsTeamB;
	private JSlider slider_speed;
	private JLabel dyn_actionA2;
	private JLabel dyn_actionA1;
	private JLabel lbl_ActionB1;
	private JLabel dyn_actionB1;
	private JLabel lbl_actionB2;
	private JLabel dyn_actionB2;
	public JToggleButton tglbtnPause;
	private JLabel lbl_playedNumberOfSets;
	private JLabel lbl_SetsToPlay;
	private JLabel lblMaxsets;
	private JLabel lblInfoText;
	private JLabel lblAttackText;
	private JLabel lblBlockInfoText;
	
	public ViewSimFrame(){
		super("View Simulation");
		
		Game game = Game.getInstance();
		final MainFrame mainFrame = GUIManager.getInstance().getMainFrame();
		
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); 
        drawingPanel = new DrawingPanel();
        getContentPane().add(drawingPanel);
        drawingPanel.setLayout(null);
        
        lbl_currentstate = new JLabel(game.getCurrentState().toString());
        lbl_currentstate.setBounds(267, 680, 400, 16);
        lbl_currentstate.setVerticalAlignment(SwingConstants.TOP);
        lbl_currentstate.setHorizontalAlignment(SwingConstants.CENTER);
        drawingPanel.add(lbl_currentstate);
        
        JLabel lblMaxpoints = new JLabel("Played Sets:");
        lblMaxpoints.setBounds(22, 86, 92, 16);
        drawingPanel.add(lblMaxpoints);
        
        slider_speed = new JSlider();
        slider_speed.addMouseListener(new MouseAdapter() {
        	@Override
        	public void mouseReleased(MouseEvent e) {
        		// Wert des Sliders wird von 2001 abgezogen, damit links langsam und rechts schneller ist
        		mainFrame.mySimSwingWorker.waitTime = 2001-slider_speed.getValue();
        	}
        });
        slider_speed.setMinimum(1); 
        slider_speed.setMaximum(2000);
        slider_speed.setBounds(6, 177, 179, 34);
        slider_speed.setValue(mainFrame.getEditPane().getSLider_speed().getValue());
        drawingPanel.add(slider_speed);
               
        
        JLabel lblSpeed = new JLabel("Speed:");
        lblSpeed.setBounds(21, 151, 61, 16);
        drawingPanel.add(lblSpeed);
        
        // Hit Info
        JLabel lblInfo = new JLabel("Hit Info:");
        lblInfo.setBounds(21, 255, 61, 16);
        drawingPanel.add(lblInfo);
        
        JPanel InfoPannel = new JPanel();
        InfoPannel.setBounds(21, 275, 180, 28);
        InfoPannel.setBackground(Color.WHITE);
        drawingPanel.add(InfoPannel);
        
        lblInfoText = new JLabel("Info Schlagausfuehrung");
        InfoPannel.add(lblInfoText);
        
        // Block Info
        JLabel lblBlockInfo = new JLabel("Block Info:");
        lblBlockInfo.setBounds(21, 325, 70, 16);
        drawingPanel.add(lblBlockInfo);
        
        JPanel BlockInfoPannel = new JPanel();
        BlockInfoPannel.setBounds(21, 345, 180, 28);
        BlockInfoPannel.setBackground(Color.WHITE);
        drawingPanel.add(BlockInfoPannel);
        
        lblBlockInfoText = new JLabel("Info Schlagausfuehrung");
        BlockInfoPannel.add(lblBlockInfoText);
        
        
        // Attack Info
        JLabel lblAttack = new JLabel("Attack Info:");
        lblAttack.setBounds(21, 395, 70, 16);
        drawingPanel.add(lblAttack);
        
        JPanel AttackPannel = new JPanel();
        AttackPannel.setBounds(21, 415, 180, 28);
        AttackPannel.setBackground(Color.WHITE);
        drawingPanel.add(AttackPannel);
        
        lblAttackText = new JLabel("Info Attacks");
        AttackPannel.add(lblAttackText);
        
        
        txt_pointsTeamA = new JLabel();
        txt_pointsTeamA.setBounds(365, 646, 50, 22);
        txt_pointsTeamA.setHorizontalAlignment(SwingConstants.CENTER);
        txt_pointsTeamA.setOpaque(true);
        txt_pointsTeamA.setBackground(Color.WHITE);
        drawingPanel.add(txt_pointsTeamA);
        
        txt_pointsTeamB = new JLabel();
        txt_pointsTeamB.setBounds(441, 646, 50, 22);
        txt_pointsTeamB.setHorizontalAlignment(SwingConstants.CENTER);
        txt_pointsTeamB.setOpaque(true);
        txt_pointsTeamB.setBackground(Color.WHITE);
        drawingPanel.add(txt_pointsTeamB);
        
        JLabel lbl_nameTeamA = new JLabel(game.getTeamA().name);
        lbl_nameTeamA.setBounds(292, 649, 61, 16);
        drawingPanel.add(lbl_nameTeamA);
        
        JLabel lbl_nameTeamB = new JLabel(game.getTeamB().name);
        lbl_nameTeamB.setBounds(503, 649, 61, 16);
        drawingPanel.add(lbl_nameTeamB);
        
        JButton btnClose = new JButton("Close");
        btnClose.setBounds(576, 745, 117, 29);
        drawingPanel.add(btnClose);
        
        JLabel lbl_TeamA = new JLabel("Team " + game.getTeamA().name);
        lbl_TeamA.setBounds(665, 95, 100, 16);
        drawingPanel.add(lbl_TeamA);
        
        JLabel lbl_ActionA1 = new JLabel("Hit " + game.getTeamA().getPlayer1().getName());
        lbl_ActionA1.setBounds(665, 115, 100, 16);
        drawingPanel.add(lbl_ActionA1);
        
        JLabel lbl_ActionA2 = new JLabel("Hit " + game.getTeamA().getPlayer2().getName());
        lbl_ActionA2.setBounds(665, 185, 100, 16);
        drawingPanel.add(lbl_ActionA2);
        
        dyn_actionA1 = new JLabel("dyn Action A1");
        dyn_actionA1.setHorizontalAlignment(SwingConstants.CENTER);
        dyn_actionA1.setBounds(665, 145, 126, 28);
        dyn_actionA1.setOpaque(true);
        dyn_actionA1.setBackground(Color.WHITE);
        drawingPanel.add(dyn_actionA1);        
        
        dyn_actionA2 = new JLabel("dyn Action A2");
        dyn_actionA2.setHorizontalAlignment(SwingConstants.CENTER);
        dyn_actionA2.setBounds(665, 223, 126, 28);
        dyn_actionA2.setOpaque(true);
        dyn_actionA2.setBackground(Color.WHITE);
        drawingPanel.add(dyn_actionA2);
        
        JLabel lbl_TeamB = new JLabel("Team " + game.getTeamB().name);
        lbl_TeamB.setBounds(665, 343, 100, 16);
        drawingPanel.add(lbl_TeamB);
        
        
        lbl_ActionB1 = new JLabel("Hit "+ ((Team) game.getTeamB()).getPlayer1().getName());
        lbl_ActionB1.setBounds(665, 363, 100, 16);
        drawingPanel.add(lbl_ActionB1);
        lbl_actionB2 = new JLabel("Hit " + ((Team) game.getTeamB()).getPlayer2().getName());
        lbl_actionB2.setBounds(665, 450, 100, 16);
        drawingPanel.add(lbl_actionB2); 

        dyn_actionB1 = new JLabel("dyn Action B1");
        dyn_actionB1.setHorizontalAlignment(SwingConstants.CENTER);
        dyn_actionB1.setBounds(665, 391, 126, 28);
        dyn_actionB1.setOpaque(true);
        dyn_actionB1.setBackground(Color.WHITE);
        drawingPanel.add(dyn_actionB1);
        
        dyn_actionB2 = new JLabel("dyn Action B2");
        dyn_actionB2.setHorizontalAlignment(SwingConstants.CENTER);
        dyn_actionB2.setBounds(665, 478, 126, 28);
        dyn_actionB2.setOpaque(true);
        dyn_actionB2.setBackground(Color.WHITE);
        drawingPanel.add(dyn_actionB2);
        
        tglbtnPause = new JToggleButton("Pause");
        tglbtnPause.setBounds(42, 224, 104, 29);
        drawingPanel.add(tglbtnPause);
        
        tglbtnPause.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				mainFrame.mySimSwingWorker.interruped = tglbtnPause.isSelected();
			}
		});
        
        lbl_playedNumberOfSets = new JLabel("0");
        lbl_playedNumberOfSets.setHorizontalAlignment(SwingConstants.CENTER);
        lbl_playedNumberOfSets.setOpaque(true);
        lbl_playedNumberOfSets.setBackground(Color.WHITE);
        lbl_playedNumberOfSets.setBounds(71, 108, 91, 31);
        drawingPanel.add(lbl_playedNumberOfSets);
        
        lbl_SetsToPlay = new JLabel("Sets to play:");
        lbl_SetsToPlay.setBounds(22, 26, 109, 16);
        drawingPanel.add(lbl_SetsToPlay);
        
        lblMaxsets = new JLabel(String.valueOf(mainFrame.getEditPane().spinner_MaxNumberOfSets.getValue()));
        lblMaxsets.setBounds(116, 26, 61, 16);
        drawingPanel.add(lblMaxsets);
        
        JButton btnSpeedUp = new JButton("Speed Up");
        btnSpeedUp.setBounds(719, 745, 117, 29);
        drawingPanel.add(btnSpeedUp);
               
        btnSpeedUp.addActionListener(new ActionListener(){
        	@Override
        	public void actionPerformed(ActionEvent arg0) {
				ViewSimFrame.this.dispose();
				SimSwingWorker simSwingWorker = GUIManager.getInstance().getMainFrame().getMySimSwingWorker();
				simSwingWorker.gui = false;
				
				GUIManager.getInstance().getMainFrame().dialog = new WaitDialog();
				GUIManager.getInstance().getMainFrame().dialog.updateWaitDialog(simSwingWorker.simManager.getWonSetsTeamA()+simSwingWorker.simManager.getWonSetsTeamB());
				GUIManager.getInstance().getMainFrame().dialog.setLocationRelativeTo(GUIManager.getInstance().getMainFrame());
				GUIManager.getInstance().getMainFrame().dialog.setVisible(true);
			}
        });
        
        
        btnClose.addActionListener(new ActionListener() {		
			@Override
			public void actionPerformed(ActionEvent arg0) {
				ViewSimFrame.this.dispose();
				mainFrame.getMySimSwingWorker().cancel(true);	
			}
		});
        
        this.setResizable(false);
        this.pack();
	}
	
	
	public void repaintState(boolean isNewState, State s, String hitInfoText, String attackInfoText, String blockInfoText){
			Game game = Game.getInstance();
		
			lblInfoText.setText(hitInfoText);
			lblAttackText.setText(attackInfoText);
			lblBlockInfoText.setText(blockInfoText);
			lbl_currentstate.setText(s.toString());
			
			// Punktestand aktualisieren
			txt_pointsTeamA.setText(game.getPointsTeamA()+"");
			txt_pointsTeamB.setText(game.getPointsTeamB()+"");
			
//			lbl_playedNumberOfSets.setText(String.valueOf(SimulationManager.getSimulationManager().teamA_attackStatistics.size()));
		
		if (!State.POINT_A.contains(s) && !State.POINT_B.contains(s)){	
			try {
				dyn_actionA1.setText(game.getTeamA().getTeamAction().getActionPlayer1().toStringLong());
				dyn_actionA2.setText(game.getTeamA().getTeamAction().getActionPlayer2().toStringLong());

				dyn_actionB1.setText(((Team) game.getTeamB()).getTeamAction().getActionPlayer1().toStringLong());
				dyn_actionB2.setText(((Team) game.getTeamB()).getTeamAction().getActionPlayer2().toStringLong());
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			drawingPanel.isNewState = isNewState;
			drawingPanel.repaint();
		}
	}
	
	
	public JSlider getSlider_speed(){
		return slider_speed;
	}


	public JLabel getLblInfoText() {
		return lblInfoText;
	}


	public JLabel getLblAttackText() {
		return lblAttackText;
	}

	public JLabel getLblBlockInfoText() {
		return lblBlockInfoText;
	}
}

class DrawingPanel extends JPanel {
	
	private static final long serialVersionUID = -3635277571442039262L;
	
	boolean isNewState;
	int scale = 30;
	
	public DrawingPanel() {
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(850,800);
    }
    
    // overrides paintComponent in Superclass 
    protected void paintComponent(Graphics g) {
    	// call paint Component from the Superclass
    	super.paintComponent(g);
        Graphics2D g2 = (Graphics2D) g;
        
        // Versatz Ecke oben links
        int x = 305;
        int y = 80;
        
        g2.setColor(Color.BLACK);
        g2.setColor(new Color(255,250,240));
        int margin=50;
        g2.fillRect(x-margin, y-margin, (scale*8)+2*margin, (scale*16)+2*margin);
        
        int small_scale = 3;
        
        g2.setColor(Color.BLACK);
        g2.setStroke(new BasicStroke(3));       
        g2.drawRect(x,y,scale*8,scale*16);
        g2.drawLine(x, y+scale*8, x+scale*8, y+scale*8);
        g2.setStroke(new BasicStroke(1));
        g2.drawLine(x, y+small_scale*35, x+scale*8, y+small_scale*35);
        g2.drawLine(x, y+small_scale*75, x+scale*8, y+small_scale*75);
        g2.drawLine(x, y+small_scale*85, x+scale*8, y+small_scale*85);
        g2.drawLine(x, y+small_scale*125, x+scale*8, y+small_scale*125);
        g2.drawLine(x, y+scale*16, x+scale*8, y+scale*16);
        g2.drawLine(x+scale*1, y, x+scale*1, y+scale*16);
        g2.drawLine(x+scale*4, y, x+scale*4, y+scale*16);
        g2.drawLine(x+scale*7, y, x+scale*7, y+scale*16);
        
        
        // gestrichelte Randlinien malen
        g2.setStroke(new BasicStroke(1,    // Width
                BasicStroke.CAP_SQUARE,    // End cap
                BasicStroke.JOIN_MITER,    // Join style
                10.0f,                     // Miter limit
                new float[] {1f,3f}, // Dash pattern
                0.0f));
        // links horizontal
        g2.drawLine(x+small_scale*(-15), y, x, y);
        g2.drawLine(x+small_scale*(-15), y+small_scale*35, x, y+small_scale*35);
        g2.drawLine(x+small_scale*(-15), y+small_scale*75, x, y+small_scale*75);
        g2.drawLine(x+small_scale*(-15), y+small_scale*80, x, y+small_scale*80);
        g2.drawLine(x+small_scale*(-15), y+small_scale*85, x, y+small_scale*85);
        g2.drawLine(x+small_scale*(-15), y+small_scale*125, x, y+small_scale*125);
        g2.drawLine(x+small_scale*(-15), y+small_scale*160, x, y+small_scale*160);
        // rechts horizontal
        g2.drawLine(x+small_scale*(80), y, x+small_scale*(95), y);
        g2.drawLine(x+small_scale*(80), y+small_scale*35, x+small_scale*(95), y+small_scale*35);
        g2.drawLine(x+small_scale*(80), y+small_scale*75, x+small_scale*(95), y+small_scale*75);
        g2.drawLine(x+small_scale*(80), y+small_scale*80, x+small_scale*(95), y+small_scale*80);
        g2.drawLine(x+small_scale*(80), y+small_scale*85, x+small_scale*(95), y+small_scale*85);
        g2.drawLine(x+small_scale*(80), y+small_scale*125, x+small_scale*(95), y+small_scale*125);
        g2.drawLine(x+small_scale*(80), y+small_scale*160, x+small_scale*(95), y+small_scale*160);
        // oben vertikal
        g2.drawLine(x, y, x, y+small_scale*(-15));
        g2.drawLine(x+small_scale*(10), y, x+small_scale*(10), y+small_scale*(-15));
        g2.drawLine(x+small_scale*(40), y, x+small_scale*(40), y+small_scale*(-15));
        g2.drawLine(x+small_scale*(70), y, x+small_scale*(70), y+small_scale*(-15));
        g2.drawLine(x+small_scale*(80), y, x+small_scale*(80), y+small_scale*(-15));
        //unten vertikal
        g2.drawLine(x, y+scale*16, x, y+small_scale*(175));
        g2.drawLine(x+small_scale*(10), y+scale*16, x+small_scale*(10), y+small_scale*(175));
        g2.drawLine(x+small_scale*(40), y+scale*16, x+small_scale*(40), y+small_scale*(175));
        g2.drawLine(x+small_scale*(70), y+scale*16, x+small_scale*(70), y+small_scale*(175));
        g2.drawLine(x+small_scale*(80), y+scale*16, x+small_scale*(80), y+small_scale*(175));
        
        
        // Legende, Symbole hinter Namen
        g2.setColor(new Color(0,0,255));
        g2.fill(drawTriangle(765, 115, 15));
        g2.fillRect(765, 185, 15, 15);
        g2.setColor(new Color(255,0,255));
        g2.fill(drawTriangle(765, 363, 15));
        g2.fillRect(765, 450, 15, 15);
        
        Game game = Game.getInstance();
        State s = game.getCurrentState();
        
        if(!State.POINT_A.contains(s) && !State.POINT_B.contains(s)){
	        g2.setStroke(new BasicStroke(2));
	        
	        // Team A in blau
	        g2.setColor(new Color(0,0,255));
	        g2.drawPolygon(drawTriangle(x+scale*s.getFieldA1().getX(), y+scale*s.getFieldA1().getY(), scale));
	        g2.drawRect((int) (x+scale*s.getFieldA2().getX()), (int) (y+scale*s.getFieldA2().getY()), scale, scale);
	        
	        // Team B in Pink
	        g2.setColor(new Color(255,0,255));
	        g2.drawPolygon(drawTriangle(x+scale*s.getFieldB1().getX(), y+scale*s.getFieldB1().getY(), scale));
	        g2.drawRect((int) (x+scale*s.getFieldB2().getX()), (int) (y+scale*s.getFieldB2().getY()), scale, scale);
	        
	        // Ball in gruen
	        g2.setColor(new Color(0,255,0));
	        g2.fillOval((int) (x+scale*s.getFieldBall().getX()), (int) (y+scale*s.getFieldBall().getY()), scale, scale);
	        
	        Player[] PlayerArray; 
	        

        	PlayerArray = new Player[]{game.getTeamA().getPlayer1(),game.getTeamA().getPlayer2(),
					((Team) game.getTeamB()).getPlayer1(), ((Team) game.getTeamB()).getPlayer2()};

	        
	        // Aktionen visualisieren, falls kein neuer Zustand
	        if (!isNewState){ 
	        
		        for (Player p : PlayerArray){
		        	
		        	// Hit
		        	if (p.getPlayerAction().getHit()!= Hit.nohit){
			        	Hit h = p.getPlayerAction().getHit();  
			        	g2.setColor(new Color(0,255,0));
			        	g2.drawOval((int) (x+scale*h.getTargetField().getX()), (int) (y+scale*h.getTargetField().getY()), scale, scale);
		        	}
		        	
		        	// Spieler macht eine Bewegung
		        	if (p.getPlayerAction().getMove() != Move.stay){
		        		
		        		g2.setColor(Color.LIGHT_GRAY);
			        	int degree = 0;
			        	int posX = (int) (x+scale*p.getField().getX());
			        	int posY = (int) (y+scale*p.getField().getY());
        		
			        	// One field step
			        	if (p.getPlayerAction().getMove() == Move.m_b && p.getTeam() == game.getTeamA()
			        		 ||	p.getPlayerAction().getMove() == Move.m_f && p.getTeam() == game.getTeamB()
			        		 || p.getPlayerAction().getMove() == Move.M_b && p.getTeam() == game.getTeamA()
					         ||	p.getPlayerAction().getMove() == Move.M_f && p.getTeam() == game.getTeamB()){
			        		//kein shift keine drehung notwendig
			        	}
			        	if (p.getPlayerAction().getMove() == Move.m_f && p.getTeam() == game.getTeamA()
			        		 ||	p.getPlayerAction().getMove() == Move.m_b && p.getTeam() == game.getTeamB()
			        		 || p.getPlayerAction().getMove() == Move.M_f && p.getTeam() == game.getTeamA()
					         ||	p.getPlayerAction().getMove() == Move.M_b && p.getTeam() == game.getTeamB()){ 
			        		degree = 180;
			        	}
			        	if (p.getPlayerAction().getMove() == Move.m_l && p.getTeam() == game.getTeamA()
			        		 ||	p.getPlayerAction().getMove() == Move.m_r && p.getTeam() == game.getTeamB()
			        		 || p.getPlayerAction().getMove() == Move.M_l && p.getTeam() == game.getTeamA()
					         ||	p.getPlayerAction().getMove() == Move.M_r && p.getTeam() == game.getTeamB()){
			        		degree = 90;
			        	}
			        	if (p.getPlayerAction().getMove() == Move.m_r && p.getTeam() == game.getTeamA()
			        		 ||	p.getPlayerAction().getMove() == Move.m_l && p.getTeam() == game.getTeamB()
			        		 || p.getPlayerAction().getMove() == Move.M_r && p.getTeam() == game.getTeamA()
					         ||	p.getPlayerAction().getMove() == Move.M_l && p.getTeam() == game.getTeamB()){
			        		degree = 270;
			        	}
			        	if (p.getPlayerAction().getMove() == Move.m_bl && p.getTeam() == game.getTeamA()
			        		 ||	p.getPlayerAction().getMove() == Move.m_fr && p.getTeam() == game.getTeamB()){
				        	degree = 45;
			        	}
			        	if (p.getPlayerAction().getMove() == Move.m_lf && p.getTeam() == game.getTeamA()
				        		 ||	p.getPlayerAction().getMove() == Move.m_rb && p.getTeam() == game.getTeamB()){
					        degree = 135;
				        }
			        	if (p.getPlayerAction().getMove() == Move.m_fr && p.getTeam() == game.getTeamA()
				        		 ||	p.getPlayerAction().getMove() == Move.m_bl && p.getTeam() == game.getTeamB()){
					        degree = 225;
				        }
			        	if (p.getPlayerAction().getMove() == Move.m_rb && p.getTeam() == game.getTeamA()
				        		 ||	p.getPlayerAction().getMove() == Move.m_lf && p.getTeam() == game.getTeamB()){
					        degree = 315;
				        }
			        	
			        	int drawPosX = (int) (posX*Math.cos(Math.toRadians(-degree)) - posY*Math.sin(Math.toRadians(-degree)));
			        	int drawPosY = (int) (posX*Math.sin(Math.toRadians(-degree)) + posY*Math.cos(Math.toRadians(-degree)));
			        	if (drawPosX<0) drawPosX=drawPosX-scale;
			        	if (drawPosY<0) drawPosY=drawPosY-scale;
			        	g2.rotate(Math.toRadians(degree));			        	
			        	if (Move.MOVE_ONESTEP.contains(p.getPlayerAction().getMove())){
			        		g2.drawPolygon(drawArrow(drawPosX, drawPosY, (int) (this.scale*0.5)));
			        	};
			        	if (Move.MOVE_TWOSTEPS.contains(p.getPlayerAction().getMove())){
			        		g2.drawPolygon(drawArrow(drawPosX, drawPosY, this.scale));
			        	};		        	
			        	g2.rotate(Math.toRadians(-degree));
			        			        	
		        	}
		        }  
	        
	        }// Ende Aktionen visualisieren
   
        }
    }  
    
    private Polygon drawTriangle(double d, double e, int arrowScale){
    	int x = (int) Math.round(d);
    	int y = (int) Math.round(e);
    	Polygon poly = new Polygon(new int[]{x,x+arrowScale,(int) (x+arrowScale*0.5)}, new int[]{y,y,y+arrowScale}, 3);
    	return poly;
    }
    
    private Polygon drawArrow(double d, double e, int ArrowScale){
    	int x = (int) Math.round(d);
    	if (ArrowScale < this.scale){
    		x = x + (int) Math.round(this.scale*0.25);
    	}   	
    	int y = (int) Math.round(e)-2;	
    	Polygon poly = new Polygon(new int[]{x,x, (int) (x-(ArrowScale*0.5)), (int) ((x+x+ArrowScale)*0.5), (int) ((x+ArrowScale)+(ArrowScale*0.5)), x+ArrowScale, x+ArrowScale},
		new int[]{y,y-ArrowScale,y-ArrowScale,y-2*ArrowScale, y-ArrowScale,y-ArrowScale,y}, 7);
    	return poly;
    }  
    
}