package de.ubt.wm.sb.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;

import javax.swing.Box;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import de.ubt.wm.sb.model.Game;

public class WaitDialog extends JDialog{
	
	private static final long serialVersionUID = -1376517129257929094L;

	private JLabel lbl_Score;
	private JLabel lblNumbersets;
	
	public WaitDialog(){
		super(GUIManager.getInstance().getMainFrame(), "Wait Dialog", ModalityType.APPLICATION_MODAL);
		setBackground(Color.WHITE);
		constructWaitDialog();
	}

	private void constructWaitDialog(){
		getContentPane().setLayout(new GridLayout(0, 1, 0, 0));
	    JPanel panel = new JPanel();
	    panel.setBackground(Color.WHITE);
	    GridBagLayout gbl_panel = new GridBagLayout();
	    gbl_panel.columnWidths = new int[]{30, 106, 30, 60, 0, 0};
	    gbl_panel.rowHeights = new int[]{0, 26, 20, 0, 0, 0};
	    gbl_panel.columnWeights = new double[]{0.0, 1.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    panel.setLayout(gbl_panel);
	    
	    Component rigidArea = Box.createRigidArea(new Dimension(20, 20));
	    GridBagConstraints gbc_rigidArea = new GridBagConstraints();
	    gbc_rigidArea.insets = new Insets(0, 0, 5, 0);
	    gbc_rigidArea.gridx = 4;
	    gbc_rigidArea.gridy = 0;
	    panel.add(rigidArea, gbc_rigidArea);
	    getContentPane().add(panel);
	    
	    JLabel lblScore = new JLabel("score:");
	    lblScore.setFont(new Font("Lucida Grande", Font.BOLD, 13));
	    GridBagConstraints gbc_lblScore = new GridBagConstraints();
	    gbc_lblScore.anchor = GridBagConstraints.EAST;
	    gbc_lblScore.insets = new Insets(0, 0, 5, 5);
	    gbc_lblScore.gridx = 1;
	    gbc_lblScore.gridy = 1;
	    panel.add(lblScore, gbc_lblScore);
	    
	    lbl_Score = new JLabel("lbl_Score");
	    lbl_Score.setBackground(Color.LIGHT_GRAY);
	    GridBagConstraints gbc_lbl_Score = new GridBagConstraints();
	    gbc_lbl_Score.insets = new Insets(0, 0, 5, 5);
	    gbc_lbl_Score.gridx = 3;
	    gbc_lbl_Score.gridy = 1;
	    panel.add(lbl_Score, gbc_lbl_Score);
	    
	    JLabel lblPlayedSets = new JLabel("played sets:");
	    lblPlayedSets.setFont(new Font("Lucida Grande", Font.BOLD, 13));
	    GridBagConstraints gbc_lblPlayedSets = new GridBagConstraints();
	    gbc_lblPlayedSets.anchor = GridBagConstraints.EAST;
	    gbc_lblPlayedSets.insets = new Insets(0, 0, 5, 5);
	    gbc_lblPlayedSets.gridx = 1;
	    gbc_lblPlayedSets.gridy = 3;
	    panel.add(lblPlayedSets, gbc_lblPlayedSets);
	    
	    lblNumbersets = new JLabel("numberSets");
	    lblNumbersets.setBackground(Color.LIGHT_GRAY);
	    GridBagConstraints gbc_lblNumbersets = new GridBagConstraints();
	    gbc_lblNumbersets.insets = new Insets(0, 0, 5, 5);
	    gbc_lblNumbersets.gridx = 3;
	    gbc_lblNumbersets.gridy = 3;
	    panel.add(lblNumbersets, gbc_lblNumbersets);
	    
	    Component rigidArea_1 = Box.createRigidArea(new Dimension(20, 20));
	    GridBagConstraints gbc_rigidArea_1 = new GridBagConstraints();
	    gbc_rigidArea_1.insets = new Insets(0, 0, 0, 5);
	    gbc_rigidArea_1.gridx = 0;
	    gbc_rigidArea_1.gridy = 4;
	    panel.add(rigidArea_1, gbc_rigidArea_1);
	    this.pack();
	}
	
	public void updateWaitDialog(int playedSets){
		lbl_Score.setText(Game.getInstance().printScore());
		lblNumbersets.setText(playedSets + "");
	}

}
