package de.ubt.wm.sb.model;
import java.util.Arrays;
import java.util.HashSet;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.ubt.wm.sb.sim.MainSim;

/**
 * All Fields on the court
 */	
public class Field{
	
	private static final int maxColumn = 6;
	private static final int maxRow = 8;
	
	static final Logger log4j = LogManager.getLogger(Field.class.getName());
	
	public static final Field A00 = new Field("A00", -2, -2, 0, 0);
	public static final Field A01 = new Field("A01",  0, -2, 0, 1);
	public static final Field A02 = new Field("A02",  2, -2, 0, 2);
	public static final Field A03 = new Field("A03",  5, -2, 0, 3);
	public static final Field A04 = new Field("A04",  7, -2, 0, 4);
	public static final Field A05 = new Field("A05",  9, -2, 0, 5);
	
	public static final Field A10 = new Field("A10",-2, 1.5, 1, 0);
	public static final Field A11 = new Field("A11", 0, 1.5, 1, 1);
	public static final Field A12 = new Field("A12", 2, 1.5, 1, 2);
	public static final Field A13 = new Field("A13", 5, 1.5, 1, 3);
	public static final Field A14 = new Field("A14", 7, 1.5, 1, 4);
	public static final Field A15 = new Field("A15", 9, 1.5, 1, 5);
	
	public static final Field A20 = new Field("A20",-2, 5, 2, 0);
	public static final Field A21 = new Field("A21", 0, 5, 2, 1);
	public static final Field A22 = new Field("A22", 2, 5, 2, 2);
	public static final Field A23 = new Field("A23", 5, 5, 2, 3);
	public static final Field A24 = new Field("A24", 7, 5, 2, 4);
	public static final Field A25 = new Field("A25", 9, 5, 2, 5);
	
	public static final Field A30 = new Field("A30", -2, 7, 3, 0);
	public static final Field A31 = new Field("A31", 0, 7, 3, 1);
	public static final Field A32 = new Field("A32", 2, 7, 3, 2);
	public static final Field A33 = new Field("A33", 5, 7, 3, 3);
	public static final Field A34 = new Field("A34", 7, 7, 3, 4);
	public static final Field A35 = new Field("A35", 9, 7, 3, 5);
	
	public static final Field B30 = new Field("B30", 9, 8, 4, 5);
	public static final Field B31 = new Field("B31", 7, 8, 4, 4);
	public static final Field B32 = new Field("B32", 5, 8, 4, 3);
	public static final Field B33 = new Field("B33", 2, 8, 4, 2);
	public static final Field B34 = new Field("B34", 0, 8, 4, 1);
	public static final Field B35 = new Field("B35",-2, 8, 4, 0);
	
	public static final Field B20 = new Field("B20", 9, 10, 5, 5);
	public static final Field B21 = new Field("B21", 7, 10, 5, 4);
	public static final Field B22 = new Field("B22", 5, 10, 5, 3);
	public static final Field B23 = new Field("B23", 2, 10, 5, 2);
	public static final Field B24 = new Field("B24", 0, 10, 5, 1);
	public static final Field B25 = new Field("B25", -2, 10, 5, 0);

	public static final Field B10 = new Field("B10", 9, 13.5, 6, 5);
	public static final Field B11 = new Field("B11", 7, 13.5, 6, 4);
	public static final Field B12 = new Field("B12", 5, 13.5, 6, 3);
	public static final Field B13 = new Field("B13", 2, 13.5, 6, 2);
	public static final Field B14 = new Field("B14", 0, 13.5, 6, 1);
	public static final Field B15 = new Field("B15",-2, 13.5, 6, 0);
	
	public static final Field B00 = new Field("B00", 9, 17, 7, 5);
	public static final Field B01 = new Field("B01", 7, 17, 7, 4);
	public static final Field B02 = new Field("B02", 5, 17, 7, 3);
	public static final Field B03 = new Field("B03", 2, 17, 7, 2);
	public static final Field B04 = new Field("B04", 0, 17, 7, 1);
	public static final Field B05 = new Field("B05",-2, 17, 7, 0);

	
	public static final Field[][] fieldMatrix = new Field[maxRow][maxColumn];
	static {
		fieldMatrix[0][0] = Field.A00;
		fieldMatrix[0][1] = Field.A01;
		fieldMatrix[0][2] = Field.A02;
		fieldMatrix[0][3] = Field.A03;
		fieldMatrix[0][4] = Field.A04;
		fieldMatrix[0][5] = Field.A05;
		
		fieldMatrix[1][0] = Field.A10;
		fieldMatrix[1][1] = Field.A11;
		fieldMatrix[1][2] = Field.A12;
		fieldMatrix[1][3] = Field.A13;
		fieldMatrix[1][4] = Field.A14;
		fieldMatrix[1][5] = Field.A15;
		
		fieldMatrix[2][0] = Field.A20;
		fieldMatrix[2][1] = Field.A21;
		fieldMatrix[2][2] = Field.A22;
		fieldMatrix[2][3] = Field.A23;
		fieldMatrix[2][4] = Field.A24;
		fieldMatrix[2][5] = Field.A25;
		
		fieldMatrix[3][0] = Field.A30;
		fieldMatrix[3][1] = Field.A31;
		fieldMatrix[3][2] = Field.A32;
		fieldMatrix[3][3] = Field.A33;
		fieldMatrix[3][4] = Field.A34;
		fieldMatrix[3][5] = Field.A35;
		
		fieldMatrix[4][0] = Field.B35;
		fieldMatrix[4][1] = Field.B34;
		fieldMatrix[4][2] = Field.B33;
		fieldMatrix[4][3] = Field.B32;
		fieldMatrix[4][4] = Field.B31;
		fieldMatrix[4][5] = Field.B30;
		
		fieldMatrix[5][0] = Field.B25;
		fieldMatrix[5][1] = Field.B24;
		fieldMatrix[5][2] = Field.B23;
		fieldMatrix[5][3] = Field.B22;
		fieldMatrix[5][4] = Field.B21;
		fieldMatrix[5][5] = Field.B20;
		
		fieldMatrix[6][0] = Field.B15;
		fieldMatrix[6][1] = Field.B14;
		fieldMatrix[6][2] = Field.B13;
		fieldMatrix[6][3] = Field.B12;
		fieldMatrix[6][4] = Field.B11;
		fieldMatrix[6][5] = Field.B10;
		
		fieldMatrix[7][0] = Field.B05;
		fieldMatrix[7][1] = Field.B04;
		fieldMatrix[7][2] = Field.B03;
		fieldMatrix[7][3] = Field.B02;
		fieldMatrix[7][4] = Field.B01;
		fieldMatrix[7][5] = Field.B00;
	}
		
	public static final Field[] SERVING_ZONE_A = new Field[]{A01, A02, A03, A04};
	public static final Field[] OUT_A = new Field[]{A00, A01, A02, A03, A04, A05, A10, A20, A30, A15, A25, A35};
	public static final Field[] AT_THE_NET_A = new Field[]{A31, A32, A33, A34};
	public static final Field[] AT_THE_NET_A_Array = new Field[]{A31, A32, A33, A34};
	public static final Field[] MIDDLE_ROW_A = new Field[]{A21, A22, A23, A24};
	public static final Field[] LAST_ROW_A = new Field[]{A11, A12, A13, A14};
	public static final Field[] SECOND_THIRD_ROW_A = new Field[]{A11, A12, A13, A14, A21, A22, A23, A24};
	
	public static final Field[] INSIDE_A;
	static{
		INSIDE_A = new Field[12];
		int c = 0;
    	for (int i = 1; i < maxRow/2; i++){
    		for (int j = 1; j < maxColumn-1; j++){
    			INSIDE_A[c] = Field.fieldMatrix[i][j];
    			c++;
    		}
    	}	
	}
	
	public static final HashSet<Field> SIDE_A;
	static{
		SIDE_A = new HashSet<Field>();
    	for (int i = 0; i < maxRow/2; i++){
    		for (int j = 0; j < maxColumn; j++){
    			SIDE_A.add(Field.fieldMatrix[i][j]);
    		}
    	}	
	}
	
	public static final Field[] SERVING_ZONE_B = new Field[]{B01, B02, B03, B04};
	public static final Field[] BORDER_A = new Field[]{A34, A24, A14, A13, A12, A11, A21, A31};
	public static final Field[] BORDER_LEFT_RIGHT_A = new Field[]{A34, A24, A14, A11, A21, A31};
	public static final Field[] BORDER_LEFT_RIGHT_BACKROWS_A = new Field[]{A24, A14, A11, A21};
	public static final Field[] NON_BORDER_FIELD_A = new Field[]{A12, A22, A32, A13, A23, A33};
	public static final Field[] SAFE_BACKROWS_A = new Field[]{A12, A13, A22, A23};
	
	
	public static final Field[] OUT_B = new Field[]{B00, B01, B02, B03, B04, B05, B10, B20, B30, B15, B25, B35};
	public static final Field[] AT_THE_NET_B = new Field[]{B31, B32, B33, B34};
	public static final Field[] AT_THE_NET_B_Array = new Field[]{B31, B32, B33, B34};
	public static final Field[] MIDDLE_ROW_B = new Field[]{B21, B22, B23, B24};
	public static final Field[] LAST_ROW_B = new Field[]{B11, B12, B13, B14};
	public static final Field[] SECOND_THIRD_ROW_B = new Field[]{B11, B12, B13, B14, B21, B22, B23, B24};
	
	public static final Field[] INSIDE_B = new Field[12];
	static{
		int c = 0;
    	for (int i = maxRow-2; i > maxRow/2-1; i--){
    		for (int j = maxColumn-2; j > 0; j--){
    			INSIDE_B[c] = Field.fieldMatrix[i][j];
    			c++;
    		}
    	}
	}
	
	public static final HashSet<Field> SIDE_B;
	static{
		SIDE_B = new HashSet<Field>();
    	for (int i = maxRow/2; i < maxRow; i++){
    		for (int j = 0; j < maxColumn; j++){
    			SIDE_B.add(Field.fieldMatrix[i][j]);
    		}
    	}	
	}
	
	public static final HashSet<Field> ALL = new HashSet<Field>();
	static{
		for (int i=0; i<fieldMatrix.length; i++){
			for (int j = 0; j<fieldMatrix[i].length; j++){
				ALL.add(fieldMatrix[i][j]);
			}
		}
	}
	
	public static final Field[] INSIDE_ALL = new Field[24];
	static{
		int c = 0;
    	for (int i = 0; i < INSIDE_A.length; i++){
			INSIDE_ALL[c] = INSIDE_A[i];
			c++;
    	}
    	for (int j = 0; j < INSIDE_B.length; j++){
			INSIDE_ALL[c] = INSIDE_B[j];
			c++;
    	}
	}
	
	

	public static final Field[] BORDER_B = new Field[]{B34, B24, B14, B13, B12, B11, B21, B31};
	public static final Field[] BORDER_LEFT_RIGHT_B = new Field[]{B34, B24, B14, B11, B21, B31};
	public static final Field[] BORDER_LEFT_RIGHT_BACKROWS_B = new Field[]{B24, B14, B11, B21};
	public static final Field[] NON_BORDER_FIELD_B = new Field[]{B12, B22, B32, B13, B23, B33};
	public static final Field[] SAFE_BACKROWS_B = new Field[]{B12, B13, B22, B23};
	
	
	public static final Field[] LEFT_COLUMN = new Field[]{A11,A21,A31,B34,B24,B14};
	public static final Field[] MIDDLE_LEFT_COLUMN = new Field[]{A12,A22,A32,B33,B23,B13};
	public static final Field[] MIDDLE_RIGHT_COLUMN = new Field[]{A13,A23,A33,B32,B22,B12};
	public static final Field[] RIGHT_COLUMN = new Field[]{A14,A24,A34,B31,B21,B11};
	
	public static final Field[] SERVINGFIELDS_A = new Field[]{A01, A02, A03, A04};
	public static final Field[] SERVINGFIELDS_B = new Field[]{B01, B02, B03, B04};
	
	//----------------------------------- Ende statische Variablen -------------------------------------------------------
	
	private String name;
	
	private double x;
	
	private double y;
	
	private int row;
	
	private int column;
	
    private Field(String fieldname, double x, double y, int i, int j){
    	this.name = fieldname;
    	this.x = x;
    	this.y = y;
    	this.row = i;
    	this.column = j;
    }
    
    /**
	 * Sucht aus einem HashSet von Fields zufaellig und gleichverteilt ein Field aus
	 * falls uebergebenes HashSet leer => warning
	 * @return Hit
	 */
	public static Field chooseRandomField(Field[] fields){
		if (fields.length>0){
			int l = fields.length;
			double d = MainSim.countRandomCalls();
			int n = (int) Math.round(d*(l-1));
			return fields[n];
		}else{
			log4j.warn("chooseRandomHit mit leerer Menge aufgerufen!");
			return null;
		}
		
	}
	
	public static Field[] getNeighbourOutsideFieldsOf(Field f){
		Field[] neighbours = f.getNeighbours();
		int counter = 0;
		for (int i = 0; i< neighbours.length; i++){
			if (Arrays.asList(OUT_A).contains(neighbours[i]) || Arrays.asList(OUT_B).contains(neighbours[i])){
				counter++;
			}
		}
		Field[] outsideNeighbours = new Field[counter];
		counter = 0;
		for (int i = 0; i< neighbours.length; i++){
			if (Arrays.asList(OUT_A).contains(neighbours[i]) || Arrays.asList(OUT_B).contains(neighbours[i])){
				outsideNeighbours[counter] = neighbours[i];
				counter++;
			}
		}
		return outsideNeighbours;
	}
		
	public static String printFieldMatrix(){
		StringBuffer s = new StringBuffer();
		for (int i=0; i < maxRow; i++){
			for (int j=0; j < maxColumn; j++){
				s.append(fieldMatrix[i][j].name + "\t");
			}
			s.append("\n");
		}
		return s.toString();
	}
    
	public boolean isInSameColumn(Field f){
		if (this.column == f.column){
			return true;
		}else{
			return false;
		}
	}
	
    public Move moveTowardsField(Field f){
    	if (this.isSouthOf(f) && this.isEastOf(f))return Move.m_rb;
    	if (this.isSouthOf(f) && this.isWestOf(f))return Move.m_bl;
    	if (this.isSouthOf(f) && !this.isEastOf(f) && !this.isWestOf(f))return Move.m_b;
    	
    	if (this.isNorthOf(f) && this.isEastOf(f))return Move.m_fr;
    	if (this.isNorthOf(f) && this.isWestOf(f))return Move.m_lf;
    	if (this.isNorthOf(f) &&!this.isEastOf(f) && !this.isWestOf(f))return Move.m_f;
    	
    	if (this.isEastOf(f) && !this.isNorthOf(f) && !this.isSouthOf(f)) return Move.m_r;
    	if (this.isWestOf(f) && !this.isNorthOf(f) && !this.isSouthOf(f)) return Move.m_l;
    	
    	return Move.stay;
    }
    
    
    public boolean isSouthOf(Field f){
    	if (this.belongsToSideA() && this.row > f.row) return true;
    	if (this.belongsToSideB() && this.row < f.row) return true;
    	return false;
    }
    
    public boolean isNorthOf(Field f){
    	if (this.belongsToSideA() && this.row < f.row) return true;
    	if (this.belongsToSideB() && this.row > f.row) return true;
    	return false;
    }
    
    public boolean isEastOf(Field f){
    	if (this.belongsToSideA() && this.column > f.column) return true;
    	if (this.belongsToSideB() && this.column < f.column) return true;
    	return false;
    }
    
    public boolean isWestOf(Field f){
    	if (this.belongsToSideA() && this.column < f.column) return true;
    	if (this.belongsToSideB() && this.column > f.column) return true;
    	return false;
    }
    
    public boolean isSameFieldOrOneFieldSouthOf(Field f){
    	if (this == f)
    		return true;
    	if (this.belongsToSideA() && f.belongsToSideA() && this.getRow() == f.getRow()+1){
    		return true;
    	}
    	if (this.belongsToSideB() && f.belongsToSideB() && this.getRow() == f.getRow()-1){
    		return true;
    	}
    	return false;
    }
    
    /**
     * Gibt true zurueck, wenn Field pos ein Nachbarfeld.
     * Gibt false zurueck, falls es das this = pos, also kein echtes Nachbarfeld
     * @param pos
     * @return
     */
    public boolean isNeighbour(Field pos){
    	if (pos.row == this.row && pos.column == this.column) return false;
    	if ((pos.row == this.row+1 || pos.row == this.row || pos.row == this.row-1) 
    			&& (pos.column == this.column+1 || pos.column == this.column || pos.column == this.column-1)){
    		return true;
    	}else{
    		return false;
    	}
    }
    
    /**
     * Gibt true zurueck, wenn Field pos ein Nachbarfeld oder das gleiche Feld ist
     * @param pos
     * @return
     */
    public boolean isNeighbourOrOwnField(Field pos){
    	if ((pos.row == this.row+1 || pos.row == this.row || pos.row == this.row-1) 
    			&& (pos.column == this.column+1 || pos.column == this.column || pos.column == this.column-1)){
    		return true;
    	}else{
    		return false;
    	}
    }
    
    public Field[] getNeighbours(){
    	int row = this.row;
    	int column = this.column;
    	int numberOfNeighbours = 0;
    	for (int i = -1; i<2; i++){
    		for (int j = -1; j<2; j++){
    			if (row+i >= 0 && row+i<maxRow && column+j>=0 && column+j < maxColumn && (i!=0 || j!=0))
//    			neighbours.add(Field.fieldMatrix[row+i][column+j]);
    				numberOfNeighbours++;
    		}
    	}
    	
    	Field[] neighbours = new Field[numberOfNeighbours];
    	int counter = 0;
    	if (this.belongsToSideA()){
	    	for (int i = -1; i<2; i++){
	    		for (int j = -1; j<2; j++){
	    			if (row+i >= 0 && row+i<maxRow && column+j>=0 && column+j < maxColumn && (i!=0 || j!=0)){
	    				neighbours[counter] = Field.fieldMatrix[row+i][column+j];
	    				counter++;
	    			}
	    		}
	    	}
    	}else{
    		//switch order
    		for (int i = 1; i>=-1; i--){
	    		for (int j = 1; j>=-1; j--){
	    			if (row+i >= 0 && row+i<maxRow && column+j>=0 && column+j < maxColumn && (i!=0 || j!=0)){
	    				neighbours[counter] = Field.fieldMatrix[row+i][column+j];
	    				counter++;
	    			}
	    		}
	    	}
    	}  	
    	return neighbours;
    }   
    
//    public HashSet<Field> getNeighbours(){
//    	HashSet<Field> neighbours = new HashSet<Field>();
//    	int row = this.row;
//    	int column = this.column;
//    	if (this.belongsToSideA()){
//	    	for (int i = -1; i<2; i++){
//	    		for (int j = -1; j<2; j++){
//	    			if (row+i >= 0 && row+i<maxRow && column+j>=0 && column+j < maxColumn && (i!=0 || j!=0))
//	    			neighbours.add(Field.fieldMatrix[row+i][column+j]);
//	    		}
//	    	}
//    	}
//    	else{
//    		for (int i = 1; i>-2; i--){
//	    		for (int j = 1; j>-2; j--){
//	    			if (row+i >= 0 && row+i<maxRow && column+j>=0 && column+j < maxColumn && (i!=0 || j!=0))
//	    			neighbours.add(Field.fieldMatrix[row+i][column+j]);
//	    		}
//	    	}
//    	}
//    	return neighbours;
//    }   
//    
   
    public boolean belongsToSideA(){  	
    	if (this.row < maxRow/2){
    		return true;
    	}
    	else{
    		return false;
    	}
    }
    
    public boolean belongsToSideB(){
    	if (this.row >= maxRow/2){
    		return true;
    	}
    	else{
    		return false;
    	}
    }
    
    static public HashSet<Field> getAllFieldsSideA(){
    	HashSet<Field> set = new HashSet<Field>();	
    	for (int i = 0; i < maxRow/2; i++){
    		for (int j = 0; j < maxColumn; j++){
    			set.add(Field.fieldMatrix[i][j]);
    		}
    	}	
    	return set;
    }
    
    static public HashSet<Field> getAllFieldsOfColumn(int j){
    	HashSet<Field> set = new HashSet<Field>();	
    	for (int i = 0; i < maxRow; i++){
    			set.add(Field.fieldMatrix[i][j]);
    	}	
    	return set;
    }
    
    static public HashSet<Field> getAllFieldsOfRow(int i){
    	HashSet<Field> set = new HashSet<Field>();
		for (int j = 0; j < maxColumn; j++){
			set.add(Field.fieldMatrix[i][j]);
		}		
    	return set;
    }
    
	public String getName() {
		return name;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}
	
	public int getRow() {
		return row;
	}

	public int getColumn() {
		return column;
	}

	@Override
	public String toString() {
		return  this.name;
	}

	public boolean isInsideA() {
		if (this.belongsToSideA() && !Arrays.asList(Field.OUT_A).contains(this))
			return true;
		return false;
	}
	
	public boolean isInsideB() {
		if (this.belongsToSideB() && !Arrays.asList(Field.OUT_B).contains(this))
			return true;
		return false;
	}

	public boolean isAtTheNet() {
		if (this.row == 3 || this.row == 4)
			return true;
		return false;
	}

}