package de.ubt.wm.sb.model;

import java.util.Arrays;
import java.util.HashSet;

/**
 * Move
 */	
public class Move {

	public static final Move m_b = new Move("m_b", -1, 0);
	public static final Move m_bl = new Move("m_bl", -1, 1);
	public static final Move m_l = new Move("m_l", 0, 1);
	public static final Move m_lf = new Move("m_lf", 1, 1);
	public static final Move m_f = new Move("m_f", 1, 0);
	public static final Move m_fr = new Move("m_fr", 1, -1);
	public static final Move m_r = new Move("m_r", 0, -1);
	public static final Move m_rb = new Move("m_rb", -1, -1);
	public static final Move M_b = new Move("M_b", -2, 0);
	public static final Move M_l = new Move("M_l", 0, 2);
	public static final Move M_f = new Move("M_f", 2, 0);
	public static final Move M_r = new Move("M_r", 0, -2);
	public static final Move b = new Move("b", 0, 0);
	public static final Move stay = new Move("stay", 0, 0);

	public static final HashSet<Move> ALL_MOVES;	
	static{
		ALL_MOVES = new HashSet<Move>();
		ALL_MOVES.addAll(Arrays.asList(m_b, m_bl, m_l, m_lf, m_f, m_fr, m_r, m_rb, M_b, M_l, M_f, M_r, b, stay));
	}
	
	public static final HashSet<Move> ALL_MOVES_WITHOUTBLOCKS;
	static{
		ALL_MOVES_WITHOUTBLOCKS = new HashSet<Move>();
		ALL_MOVES_WITHOUTBLOCKS.addAll(Arrays.asList(m_b, m_bl, m_l, m_lf, m_f, m_fr, m_r, m_rb, M_b, M_l, M_f, M_r, stay));
	}	
	
	public static final HashSet<Move> MOVE_ONESTEP;	
	static{
		MOVE_ONESTEP = new HashSet<Move>();
		MOVE_ONESTEP.addAll(Arrays.asList(m_b, m_bl, m_l, m_lf, m_f, m_fr, m_r, m_rb));
	}
	
	public static final HashSet<Move> MOVE_TWOSTEPS;	
	static{
		MOVE_TWOSTEPS = new HashSet<Move>();
		MOVE_TWOSTEPS.addAll(Arrays.asList(M_b, M_l, M_f, M_r));
	}
	
	private String name;
	private int delta_row; // aus der Sicht von Team A
	private int delta_column;

    private Move(String name, int delta_row, int delta_column){
    	this.name = name;
    	this.delta_row = delta_row;
    	this.delta_column = delta_column;
    }
     
	public String getName(){
		return this.name;
	}	
	
	public int getDelta_row() {
		return delta_row;
	}

	public int getDelta_column() {
		return delta_column;
	}
	    
	@Override
	public String toString() {			
		return this.name;
	}

	public boolean isBlockingAction() {
		if (this == Move.b){
			return true;
		}
		else{
			return false;
		}
	}

}