package de.ubt.wm.sb.model;

import java.util.Objects;

/**
 * PlayerAction
 */	
public class PlayerAction {

	public static final PlayerAction doNothing = new PlayerAction(Hit.nohit, Move.stay);
	
	private Hit hit;
	private Move move;

    public PlayerAction(Hit hit, Move move){
    	this.hit = hit;
    	this.move = move;
    }
     
    public Move getMove(){
    	return this.move;
    }
	
    public void setMove(Move move){
    	this.move = move;
    }

    public Hit getHit(){
    	return this.hit;
    }
	
    public void setHit(Hit hit){
    	this.hit = hit;
    }

	public String toStringLong() {			
		if (Hit.DEFENCES.contains(hit)){
			if (hit.getTechnique() == HitTechnique.d_m){
				return "defence & move";
			}else{
				return "defence";
			}
		}
		if (Hit.FLOAT_SERVE_A.contains(hit) || Hit.FLOAT_SERVE_B.contains(hit)){
			return "float serve";
		}
//		if (Hit.JUMP_FLOAT_SERVE_A.contains(hit) || Hit.JUMP_FLOAT_SERVE_B.contains(hit)){
//			return "jump float serve";
//		}
		if (Hit.JUMP_SERVE_A.contains(hit) || Hit.JUMP_SERVE_B.contains(hit)){
			return "jump serve";
		}
		if (Hit.POKE_TEAMA.contains(hit) || Hit.POKE_TEAMB.contains(hit)){
			return "poke";
		}
		if (Hit.RECEPTIONS.contains(hit)){
			if (hit.getTechnique() == HitTechnique.r_m){
				return "reception & move";
			}else{
				return "reception";
			}
		}
		if (Hit.SETTINGS.contains(hit)){
			return "set";
		}
		if (Hit.SHOT_TEAMA.contains(hit) || Hit.SHOT_TEAMB.contains(hit)){
			return "shot";
		}
		if (Hit.SMASH_TEAMA.contains(hit) || Hit.SMASH_TEAMB.contains(hit)){
			return "smash";
		}
//		if (Hit.TENNIS_SERVE_A.contains(hit) || Hit.TENNIS_SERVE_B.contains(hit)){
//			return "tennis serve";
//		}		
		if (move == Move.b){
			return "block";
		}

		return "-";
	}
	
	@Override
	public String toString() {			
		return "[" + hit.toString() + ", " + move.toString() + "]";
	}
	
	@Override
	public int hashCode(){
		return Objects.hash(
				hit,move);
	}
	
	@Override
	public boolean equals(Object o){
		if (o == this) return true;
		if (!(o instanceof PlayerAction)){
			return false;
		}
		PlayerAction pa = (PlayerAction) o;
		return hit.equals(pa.hit) && move.equals(pa.move);
	}
}