package de.ubt.wm.sb.model;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Objects;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.ubt.wm.sb.sim.MainSim;


/**
 * State
 */	
public class State implements java.io.Serializable {

	static final Logger log4j = LogManager.getLogger(State.class.getName());
	
	private static final long serialVersionUID = 1L;

	public static State POINT_A_A1=new State(Field.A00, Game.getInstance().getTeamA().getPlayer1());
	public static State POINT_A_A2=new State(Field.A00, Game.getInstance().getTeamA().getPlayer2());
	public static State POINT_A_B1=new State(Field.A00, Game.getInstance().getTeamB().getPlayer1());
	public static State POINT_A_B2=new State(Field.A00, Game.getInstance().getTeamB().getPlayer2());
	public static HashSet<State> POINT_A = new HashSet<State>();
	static{
		POINT_A.add(POINT_A_A1);
		POINT_A.add(POINT_A_A2);
		POINT_A.add(POINT_A_B1);
		POINT_A.add(POINT_A_B2);
	}
	public static State POINT_B_A1=new State(Field.B00, Game.getInstance().getTeamA().getPlayer1());
	public static State POINT_B_A2=new State(Field.B00, Game.getInstance().getTeamA().getPlayer2());
	public static State POINT_B_B1=new State(Field.B00, Game.getInstance().getTeamB().getPlayer1());
	public static State POINT_B_B2=new State(Field.B00, Game.getInstance().getTeamB().getPlayer2());
	public static HashSet<State> POINT_B = new HashSet<State>();
	static{
		POINT_B.add(POINT_B_A1);
		POINT_B.add(POINT_B_A2);
		POINT_B.add(POINT_B_B1);
		POINT_B.add(POINT_B_B2);
	}
			
	public static State Start_State_A1_A02 = new State(Field.A02, Field.A13, Field.B12, Field.B13, Field.A02, Game.getInstance().getTeamA().getPlayer1(), -1, null, BallProperty.NORMAL, null);
	public static State Start_State_A1_A03 = new State(Field.A03, Field.A13, Field.B12, Field.B13, Field.A03, Game.getInstance().getTeamA().getPlayer1(), -1, null, BallProperty.NORMAL, null);
	
	public static State Start_State_A2_A02 = new State(Field.A12, Field.A02, Field.B12, Field.B13, Field.A02, Game.getInstance().getTeamA().getPlayer2(), -1, null, BallProperty.NORMAL, null);
	public static State Start_State_A2_A03 = new State(Field.A12, Field.A03, Field.B12, Field.B13, Field.A03, Game.getInstance().getTeamA().getPlayer2(), -1, null, BallProperty.NORMAL, null);			
	
	public static State[] START_STATES_A1 = new State[]{Start_State_A1_A02, Start_State_A1_A03};
	public static State[] START_STATES_A2 = new State[]{Start_State_A2_A02, Start_State_A2_A03};
	public static State[] START_STATES_A = new State[]{Start_State_A1_A02, Start_State_A1_A03, Start_State_A2_A02, Start_State_A2_A03};

	
	public static State Start_State_B1_B02 = new State(Field.A12, Field.A13, Field.B02, Field.B13, Field.B02, Game.getInstance().getTeamB().getPlayer1(), -1, null, BallProperty.NORMAL, null);
	public static State Start_State_B1_B03 = new State(Field.A12, Field.A13, Field.B03, Field.B13, Field.B03, Game.getInstance().getTeamB().getPlayer1(), -1, null, BallProperty.NORMAL, null);
	
	public static State Start_State_B2_B02 = new State(Field.A12, Field.A13, Field.B12, Field.B02, Field.B02, Game.getInstance().getTeamB().getPlayer2(), -1, null, BallProperty.NORMAL, null);
	public static State Start_State_B2_B03 = new State(Field.A12, Field.A13, Field.B12, Field.B03, Field.B03, Game.getInstance().getTeamB().getPlayer2(), -1, null, BallProperty.NORMAL, null);			
	
	public static State[] START_STATES_B1 = new State[]{Start_State_B1_B02, Start_State_B1_B03};
	public static State[] START_STATES_B2 = new State[]{Start_State_B2_B02, Start_State_B2_B03};
	public static State[] START_STATES_B = new State[]{Start_State_B1_B02, Start_State_B1_B03, Start_State_B2_B02, Start_State_B2_B03};
	
	public static State[] START_STATES = new State[]{
			Start_State_A1_A02, Start_State_A1_A03, Start_State_A2_A02, Start_State_A2_A03,
			Start_State_B1_B02, Start_State_B1_B03, Start_State_B2_B02, Start_State_B2_B03		
	};
	
	public static void reinitializeStates(){
		POINT_A_A1=new State(Field.A00, Game.getInstance().getTeamA().getPlayer1());
		POINT_A_A2=new State(Field.A00, Game.getInstance().getTeamA().getPlayer2());
		POINT_A_B1=new State(Field.A00, Game.getInstance().getTeamB().getPlayer1());
		POINT_A_B2=new State(Field.A00, Game.getInstance().getTeamB().getPlayer2());
		POINT_A = new HashSet<State>();
		POINT_A.add(POINT_A_A1);
		POINT_A.add(POINT_A_A2);
		POINT_A.add(POINT_A_B1);
		POINT_A.add(POINT_A_B2);

		POINT_B_A1=new State(Field.B00, Game.getInstance().getTeamA().getPlayer1());
		POINT_B_A2=new State(Field.B00, Game.getInstance().getTeamA().getPlayer2());
		POINT_B_B1=new State(Field.B00, Game.getInstance().getTeamB().getPlayer1());
		POINT_B_B2=new State(Field.B00, Game.getInstance().getTeamB().getPlayer2());
		POINT_B = new HashSet<State>();
		POINT_B.add(POINT_B_A1);
		POINT_B.add(POINT_B_A2);
		POINT_B.add(POINT_B_B1);
		POINT_B.add(POINT_B_B2);

			
		Start_State_A1_A02 = new State(Field.A02, Field.A13, Field.B12, Field.B13, Field.A02, Game.getInstance().getTeamA().getPlayer1(), -1, null, BallProperty.NORMAL, null);
		Start_State_A1_A03 = new State(Field.A03, Field.A13, Field.B12, Field.B13, Field.A03, Game.getInstance().getTeamA().getPlayer1(), -1, null, BallProperty.NORMAL, null);
		
		Start_State_A2_A02 = new State(Field.A12, Field.A02, Field.B12, Field.B13, Field.A02, Game.getInstance().getTeamA().getPlayer2(), -1, null, BallProperty.NORMAL, null);
		Start_State_A2_A03 = new State(Field.A12, Field.A03, Field.B12, Field.B13, Field.A03, Game.getInstance().getTeamA().getPlayer2(), -1, null, BallProperty.NORMAL, null);			
		
		START_STATES_A1 = new State[]{Start_State_A1_A02, Start_State_A1_A03};
		START_STATES_A2 = new State[]{Start_State_A2_A02, Start_State_A2_A03};
		START_STATES_A = new State[]{Start_State_A1_A02, Start_State_A1_A03, Start_State_A2_A02, Start_State_A2_A03};

		Start_State_B1_B02 = new State(Field.A12, Field.A13, Field.B02, Field.B13, Field.B02, Game.getInstance().getTeamB().getPlayer1(), -1, null, BallProperty.NORMAL, null);
		Start_State_B1_B03 = new State(Field.A12, Field.A13, Field.B03, Field.B13, Field.B03, Game.getInstance().getTeamB().getPlayer1(), -1, null, BallProperty.NORMAL, null);
		
		Start_State_B2_B02 = new State(Field.A12, Field.A13, Field.B12, Field.B02, Field.B02, Game.getInstance().getTeamB().getPlayer2(), -1, null, BallProperty.NORMAL, null);
		Start_State_B2_B03 = new State(Field.A12, Field.A13, Field.B12, Field.B03, Field.B03, Game.getInstance().getTeamB().getPlayer2(), -1, null, BallProperty.NORMAL, null);			
		
		START_STATES_B1 = new State[]{Start_State_B1_B02, Start_State_B1_B03};
		START_STATES_B2 = new State[]{Start_State_B2_B02, Start_State_B2_B03};
		START_STATES_B = new State[]{Start_State_B1_B02, Start_State_B1_B03, Start_State_B2_B02, Start_State_B2_B03};
		
		START_STATES = new State[]{
				Start_State_A1_A02, Start_State_A1_A03, Start_State_A2_A02, Start_State_A2_A03,
				Start_State_B1_B02, Start_State_B1_B03, Start_State_B2_B02, Start_State_B2_B03		
		};
}
	
	
	private Field fieldA1;
	private Field fieldA2;
	private Field fieldB1;
	private Field fieldB2;
	private Field fieldBall;
	private Player lastServer;
	
	private int	counter;	
	private Player lastContact;
	private BallProperty ballProp;
	private Player blocker;
	
    public State(Field fieldBall, Player lastServer){
    	this.fieldBall = fieldBall;
    	this.lastServer = lastServer;
    }
  
    public State(Field fieldA1, Field fieldA2, Field fieldB1, Field fieldB2, Field fieldBall, Player lastServer,
    		int counter, Player lastContact, BallProperty ballProp, Player blocker){
		this.fieldA1 = fieldA1;
		this.fieldA2 = fieldA2;
		this.fieldB1 = fieldB1;
		this.fieldB2 = fieldB2;
		this.fieldBall = fieldBall;
		this.lastServer = lastServer;
		this.counter = counter;
		this.lastContact = lastContact;
		this.ballProp = ballProp;
		this.blocker = blocker;
    }     
    
    public State(State s) {
		this.fieldA1 = s.fieldA1;
		this.fieldA2 = s.fieldA2;
		this.fieldB1 = s.fieldB1;
		this.fieldB2 = s.fieldB2;
		this.fieldBall = s.fieldBall;
		this.lastServer = s.lastServer;
		this.counter = s.counter;
		this.lastContact = s.lastContact;
		this.ballProp = s.ballProp;
		this.blocker = s.blocker;
	}

    
    public boolean isServingState(){
    	if (Arrays.asList(State.START_STATES_A).contains(this) || Arrays.asList(State.START_STATES_B).contains(this)){
    		return true;
    	}else{
    		return false;
    	}
    }

    // alle moeglichen "Spielzustaende"
    public boolean isServingStateTeamA(){
    	if (Arrays.asList(State.START_STATES_A).contains(this))
    		return true;
    	
    	return false;
    }
     
    public boolean isReceptionStateTeamA(){
    	if (this.counter == -1 && !this.isServingState() && this.getFieldBall().belongsToSideA()){
    		return true;
    	}
    	return false;
    }
    
    public boolean isDefenceStateTeamA(){
    	if (this.counter == 0 && this.getFieldBall().belongsToSideA()){
    		return true;
    	}
    	return false;
    }
    
    public boolean isSettingStateTeamA(){
    	if (this.counter == 1 && this.getFieldBall().belongsToSideA()){
    		return true;
    	}
    	return false;
    }
    
    public boolean isAttackingStateTeamA(){
    	if (this.counter == 2 && this.getFieldBall().belongsToSideA()){
    		return true;
    	}
    	return false;
    }
    
    public boolean isServingStateTeamB(){
    	if (Arrays.asList(State.START_STATES_B).contains(this))
    		return true;
    	
    	return false;
    }
     
    public boolean isReceptionStateTeamB(){
    	if (this.counter == -1 && !this.isServingState() && this.getFieldBall().belongsToSideB()){
    		return true;
    	}
    	return false;
    }
    
    public boolean isDefenceStateTeamB(){
    	if (this.counter == 0 && this.getFieldBall().belongsToSideB()){
    		return true;
    	}
    	return false;
    }
    
    public boolean isSettingStateTeamB(){
    	if (this.counter == 1 && this.getFieldBall().belongsToSideB()){
    		return true;
    	}
    	return false;
    }
    
    public boolean isAttackingStateTeamB(){
    	if (this.counter == 2 && this.getFieldBall().belongsToSideB()){
    		return true;
    	}
    	return false;
    }

    
    
    public boolean ballOverNet(){
    	if (this.counter == 0) return true;
    	if (this.counter == -1 && !this.isServingState()) return true;
    	return false;
    }
    
    public Field getFieldOf(Player player){
    	if (Game.getInstance().getTeamA().getPlayer1() == player){
    		return fieldA1;
    	}
    	if (Game.getInstance().getTeamA().getPlayer2() == player){
    		return fieldA2;
    	}
    	if (Game.getInstance().getTeamB().getPlayer1() == player){
    		return fieldB1;
    	}
    	if (Game.getInstance().getTeamB().getPlayer2() == player){
    		return fieldB2;
    	}
    	log4j.warn("Feld von Spieler nicht gefunden, da Spieler nicht bekannt im Spiel");
    	return null;
    }
    
	public Field getFieldA1() {
		return fieldA1;
	}

	public void setFieldA1(Field fieldA1) {
		this.fieldA1 = fieldA1;
	}

	public Field getFieldA2() {
		return fieldA2;
	}

	public void setFieldA2(Field fieldA2) {
		this.fieldA2 = fieldA2;
	}

	public Field getFieldB1() {
		return fieldB1;
	}

	public void setFieldB1(Field fieldB1) {
		this.fieldB1 = fieldB1;
	}

	public Field getFieldB2() {
		return fieldB2;
	}

	public void setFieldB2(Field fieldB2) {
		this.fieldB2 = fieldB2;
	}

	public Field getFieldBall() {
		return fieldBall;
	}

	public void setFieldPosBall(Field fieldPosBall) {
		this.fieldBall = fieldPosBall;
	}

	public Player getLastServer() {
		if (lastServer == null){
//			log4j.error("Last Server does not exist in State " + this.toString());
			return null;
		}else{
			return lastServer;
		}
	}

	public void setLastServer(Player lastServer) {
		this.lastServer = lastServer;
	}

	public int getCounter(){
    	return this.counter;
    }
    
    public void setCounter(int c){
    	this.counter = c;
    }
    
    public Player getLastContact(){
    	return this.lastContact;
    }
    
    public void setLastContact(Player player){
    	this.lastContact = player;
    }
    	
	public BallProperty getBallProp() {
		return ballProp;
	}

	public void setBallProp(BallProperty ballProp) {
		this.ballProp = ballProp;
	}

	public Player getBlocker() {
		return blocker;
	}

	public void setBlocker(Player blocker) {
		this.blocker = blocker;
	}

	public void setFieldBall(Field fieldBall) {
		this.fieldBall = fieldBall;
	}

	public String toStringLong() {
		if (POINT_A.contains(this)){
			return "Punkt Team A";
		}
		if (POINT_B.contains(this)){
			return "Punkt Team B";
		}
		
		StringBuffer s = new StringBuffer();
		s.append("(fieldA1 = " + fieldA1.getName() +", " +
					"fieldA2 = " + fieldA2.getName() +", " +
					"fieldB1 = " + fieldB1.getName() +", " +
					"fieldB2 = " + fieldB2.getName() +", " +
					"fieldBall = " + fieldBall.getName() + ", ");
		if (lastServer == null){
			s.append("lastServer = -, ");
		}else{
			s.append("lastServer = " + lastServer.getName() +  ", ");
		}					
		s.append("counter = " + counter + ", ");
		if (lastContact == null){
			s.append("lastContact = -, ");
		}else{
			s.append("lastContact = " + lastContact.getName() +  ", ");
		}
		s.append("ball = " + ballProp.toString() + ", ");
		
		if (blocker == null){
			s.append("blocker = -, ");
		}else{
			s.append("blocker = " + blocker.getName() +  ") ");
		}
				
		return s.toString();
	}
	
	public static State getRandomStartStateA(){
		State[] startStateA_Array = State.START_STATES_A;
		int l = startStateA_Array.length;
		int n = MainSim.r.nextInt(l);
		return startStateA_Array[n];
	}

	public static State getRandomStartStateB(){
		State[] startStateB_Array = State.START_STATES_B;
		int l = startStateB_Array.length;
		int n = MainSim.r.nextInt(l);
		return startStateB_Array[n];
	}
	
	public static State getPointStateTeamA(Player lastServer) throws Exception{
		for (State s : State.POINT_A){
			if (s.getLastServer()==lastServer){
				return s;
			}
		}
		throw new Exception("getPointStateTeamA: Last Server is not in the game.");
	}
	
	public static State getPointStateTeamB(Player lastServer) throws Exception{
		for (State s : State.POINT_B){
			if (s.getLastServer()==lastServer){
				return s;
			}
		}
		throw new Exception("getPointStateTeamB: Last Server is not in the game.");
	}
		
	public static State chooseRandomStateOf(HashSet<State> states){
		State[] states_Array = states.toArray(new State[states.size()]);
		int l = states_Array.length;
		int n = MainSim.r.nextInt(l);
		return states_Array[n];
	}
	
	public static State chooseRandomStateOfArray(State[] states){
		State[] states_Array = states;
		int l = states_Array.length;
		int n = MainSim.r.nextInt(l);
		return states_Array[n];
	}
		
	@Override
	public String toString() {
		if (POINT_A.contains(this)){
			return "Punkt Team A";
		}
		if (POINT_B.contains(this)){
			return "Punkt Team B";
		}
		if (Arrays.asList(START_STATES_A).contains(this)){
			return "Aufschlag Team A";
		}
		if (Arrays.asList(START_STATES_B).contains(this)){
			return "Aufschlag Team B";
	    }
		StringBuffer s = new StringBuffer();
		s.append("("+fieldA1.getName() +", " +
					fieldA2.getName() +", " +
					fieldB1.getName() +", " +
					fieldB2.getName() +", " +
					fieldBall.getName() + ", ");
		if (lastServer == null){
			s.append("-, ");
		}else{
			s.append(lastServer.getName() +  ", ");
		}					
		s.append(counter + ", ");
		if (lastContact == null){
			s.append("-, ");
		}else{
			s.append(lastContact.getName() +  ", ");
		}
		s.append(ballProp.toString() + ", ");
		
		if (blocker == null){
			s.append("-, ");
		}else{
			s.append(blocker.getName());
		}
		
		s.append(")");
		
		return s.toString();
	}

	public void setField(Player hittingPlayer, Field field) {
		Game game = Game.getInstance();
		if (hittingPlayer == game.getTeamA().getPlayer1()){
			this.setFieldA1(field);
			return;
		}
		if (hittingPlayer == game.getTeamA().getPlayer2()){
			this.setFieldA2(field);
			return;
		}
		if (hittingPlayer == game.getTeamB().getPlayer1()){
			this.setFieldB1(field);
			return;
		}
		if (hittingPlayer == game.getTeamB().getPlayer2()){
			this.setFieldB2(field);
			return;
		}
		log4j.error("kein Spieler passender Spieler im Spiel");
	}
	
	
	@Override
	public int hashCode(){
		return Objects.hash(
				fieldA1,fieldA2,fieldB1,fieldB2,fieldBall,lastServer,counter,lastContact,ballProp,blocker);
	}
	
	@Override
	public boolean equals(Object o){
		if (o == this) return true;
		if (!(o instanceof State)){
			return false;
		}
		State state = (State) o;
		return fieldA1==state.fieldA1 &&
				fieldA2 == state.fieldA2 &&
				fieldB1 == state.fieldB1 &&
				fieldB2 == state.fieldB2 &&
				fieldBall == state.fieldBall &&
				lastServer == state.lastServer &&
				counter == state.counter &&
				lastContact == state.lastContact &&
				ballProp == state.ballProp &&
				blocker == state.blocker;
	}
	
}