package de.ubt.wm.sb.model.strategy;

import java.util.Arrays;

import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.Move;
import de.ubt.wm.sb.model.PlayerAction;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;
import de.ubt.wm.sb.model.HitTechnique;




public class Strat_AGG_BASIC extends Strat_BASIC_BASIC{

	private static Strat_AGG_BASIC strat_AGG_BASIC_TeamA = new Strat_AGG_BASIC(true);

	
	private Strat_AGG_BASIC(boolean isTeamA){
		super(isTeamA);
	}
	
	
	public static Strat_AGG_BASIC getInstanceTeamA(){
		return strat_AGG_BASIC_TeamA;
	}
	
	@Override
	public TeamAction servingRule(State s) {
		// zufaellig einen Aufschlag auswaehlen
		Hit h;
		if (isTeamA){
			Field f = Field.chooseRandomField(Field.BORDER_LEFT_RIGHT_BACKROWS_B);
			h = new Hit(HitTechnique.S_J, f);
		}else{
			Field f = Field.chooseRandomField(Field.BORDER_LEFT_RIGHT_BACKROWS_A);
			h = new Hit(HitTechnique.S_J, f);
		}

		Move moveServer;
		if (h.isHitWithJump()){
			moveServer = Move.m_s;
		}else{
			if (Arrays.asList(Field.OUT_A).contains(fP1)){
				moveServer = fP1.moveTowardsField(getCentralFieldOfOtherHalf(fP2));
			}else{
				moveServer = fP2.moveTowardsField(getCentralFieldOfOtherHalf(fP1));
			}
		}
		
		if (Arrays.asList(Field.OUT_A).contains(fP1) || Arrays.asList(Field.OUT_B).contains(fP1))
			return new TeamAction(new PlayerAction(h,moveServer), new PlayerAction(Hit.nohit, Move.stay));
		else
			return new TeamAction(new PlayerAction(Hit.nohit, Move.stay), new PlayerAction(h,moveServer));
	}
	
	public String toString(){
		if (this == Strat_AGG_BASIC.strat_AGG_BASIC_TeamA)
			return "Serving Strategie AGG-BASIC Team A";
		else 
			return "Serving Strategie AGG-BASIC";
	}

	public String toStringShort(){
		return "AGG-BASIC";
	}	
	
}
