package de.ubt.wm.sb.model.strategy;

import java.util.Arrays;

import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.Move;
import de.ubt.wm.sb.model.PlayerAction;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;
import de.ubt.wm.sb.model.HitTechnique;




public class Strat_BASIC_AGG extends Strat_BASIC_BASIC{

	private static Strat_BASIC_AGG strat_BASIC_AGG_TeamA = new Strat_BASIC_AGG(true);

	
	private Strat_BASIC_AGG(boolean isTeamA){
		super(isTeamA);
	}
	
	
	public static Strat_BASIC_AGG getInstanceTeamA(){
		return strat_BASIC_AGG_TeamA;
	}
	
	
	@Override
	public TeamAction attackingRule(State s){
		Field f = Field.chooseRandomField(Field.BORDER_LEFT_RIGHT_BACKROWS_B);
		Hit h = new Hit(HitTechnique.F_SM, f);
		if(s.getFieldA1()==s.getFieldBall() && s.getLastContact() != Game.getInstance().getTeamA().getPlayer1() && !Arrays.asList(Field.AT_THE_NET_A).contains(s.getFieldA1())){
			return  new TeamAction(new PlayerAction(h, Move.stay), PlayerAction.doNothing);
		}
		if(s.getFieldA2()==s.getFieldBall() && s.getLastContact() != Game.getInstance().getTeamA().getPlayer2() && !Arrays.asList(Field.AT_THE_NET_A).contains(s.getFieldA2())){
			return  new TeamAction(PlayerAction.doNothing, new PlayerAction(h, Move.stay));
		}
		// Fallback auf Basic Rule
		return Strat_BASIC_BASIC.getInstanceTeamA().getTeamAction(s);
	}
	
	public String toString(){
		if (this == Strat_BASIC_AGG.strat_BASIC_AGG_TeamA)
			return "Field Attacking Strategie BASIC-AGG Team A";
		else 
			return "Field Attacking Strategie BASIC-AGG";
	}
	
	public String toStringShort(){
		return "BASIC-AGG";
	}
	
}
