package de.ubt.wm.sb.model.strategy;

import java.util.Arrays;

import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.Move;
import de.ubt.wm.sb.model.PlayerAction;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;
import de.ubt.wm.sb.model.HitTechnique;


public class Strat_BASIC_DEF extends Strat_BASIC_BASIC{

	private static Strat_BASIC_DEF strat_BASIC_DEF_TeamA = new Strat_BASIC_DEF(true);

	
	private Strat_BASIC_DEF(boolean isTeamA){
		super(isTeamA);
	}
	
	
	public static Strat_BASIC_DEF getInstanceTeamA(){
		return strat_BASIC_DEF_TeamA;
	}
	
	
	@Override
	public TeamAction attackingRule(State s){
		Field f = Field.chooseRandomField(Field.SAFE_BACKROWS_B);
		Hit h = new Hit(HitTechnique.F_P, f);
		if(s.getFieldA1()==s.getFieldBall() && s.getLastContact() != Game.getInstance().getTeamA().getPlayer1() && !Arrays.asList(Field.AT_THE_NET_A).contains(s.getFieldA1())){
			return  new TeamAction(new PlayerAction(h, Move.stay), PlayerAction.doNothing);
		}
		if(s.getFieldA2()==s.getFieldBall() && s.getLastContact() != Game.getInstance().getTeamA().getPlayer2() && !Arrays.asList(Field.AT_THE_NET_A).contains(s.getFieldA2())){
			return  new TeamAction(PlayerAction.doNothing, new PlayerAction(h, Move.stay));
		}
		
		// Fallback auf Basic Strategy
		return Strat_BASIC_BASIC.getInstanceTeamA().getTeamAction(s);
	}

	public String toString(){
		if (this == Strat_BASIC_DEF.strat_BASIC_DEF_TeamA)
			return "Field Attacking Strategie BAISC-DEF Team A";
		else 
			return "Field Attacking Strategie BASIC-DEF";
	}
	
	public String toStringShort(){
		return "BASIC-DEF";
	}
}
