package de.ubt.wm.sb.model.strategy;

import java.util.Arrays;

import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.Move;
import de.ubt.wm.sb.model.PlayerAction;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;
import de.ubt.wm.sb.model.HitTechnique;


public class Strat_DEF_DEF extends Strat_BASIC_BASIC{

	private static Strat_DEF_DEF strat_DEF_DEF_TeamA = new Strat_DEF_DEF(true);

	
	private Strat_DEF_DEF(boolean isTeamA){
		super(isTeamA);
	}
	
	
	public static Strat_DEF_DEF getInstanceTeamA(){
		return strat_DEF_DEF_TeamA;
	}
	
	@Override
	public TeamAction servingRule(State s) {
		// zufaellig einen Aufschlag auswaehlen
		Hit h;
		if (isTeamA){
			Field f = Field.chooseRandomField(Field.SAFE_BACKROWS_B);
			h = new Hit(HitTechnique.S_F, f);
		}else{
			Field f = Field.chooseRandomField(Field.SAFE_BACKROWS_A);
			h = new Hit(HitTechnique.S_F, f);
		}

		Move moveServer;
		if (h.isHitWithJump()){
			moveServer = Move.m_s;
		}else{
			if (Arrays.asList(Field.OUT_A).contains(fP1)){
				moveServer = fP1.moveTowardsField(getCentralFieldOfOtherHalf(fP2));
			}else{
				moveServer = fP2.moveTowardsField(getCentralFieldOfOtherHalf(fP1));
			}
		}
		
		if (Arrays.asList(Field.OUT_A).contains(fP1) || Arrays.asList(Field.OUT_B).contains(fP1))
			return new TeamAction(new PlayerAction(h,moveServer), new PlayerAction(Hit.nohit, Move.stay));
		else
			return new TeamAction(new PlayerAction(Hit.nohit, Move.stay), new PlayerAction(h,moveServer));
	}

	@Override
	public TeamAction attackingRule(State s){
		Field f = Field.chooseRandomField(Field.SAFE_BACKROWS_B);
		Hit h = new Hit(HitTechnique.F_P, f);
		if(s.getFieldA1()==s.getFieldBall() && s.getLastContact() != Game.getInstance().getTeamA().getPlayer1() && !Arrays.asList(Field.AT_THE_NET_A).contains(s.getFieldA1())){
			return  new TeamAction(new PlayerAction(h, Move.stay), PlayerAction.doNothing);
		}
		if(s.getFieldA2()==s.getFieldBall() && s.getLastContact() != Game.getInstance().getTeamA().getPlayer2() && !Arrays.asList(Field.AT_THE_NET_A).contains(s.getFieldA2())){
			return  new TeamAction(PlayerAction.doNothing, new PlayerAction(h, Move.stay));
		}
		
		// Fallback auf Basic Strategy
		return Strat_BASIC_BASIC.getInstanceTeamA().getTeamAction(s);
	}
	
	public String toString(){
		if (this == Strat_DEF_DEF.strat_DEF_DEF_TeamA)
			return "Strategie DEF-DEF Team A";
		else 
			return "Strategie DEF-DEF";
	}
	
	public String toStringShort(){
			return "DEF-DEF";
	}
}
