package de.ubt.wm.sb.model.strategy;

import java.util.Arrays;

import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.Hit;
import de.ubt.wm.sb.model.HitTechnique;
import de.ubt.wm.sb.model.Move;
import de.ubt.wm.sb.model.Player;
import de.ubt.wm.sb.model.PlayerAction;
import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;
import de.ubt.wm.sb.sim.MainSim;

public class Strat_calibrate extends Strat_BASIC_BASIC {
	
	// TODO p_b ueberpruefen, dass es zu finale passt
	private static Strat_calibrate strat_cali_finalMatch_TeamA = new Strat_calibrate(true, 0.03, new double[][] {{0.5, 0.08, 0.74, 0.24},{0.31, 0.17, 0.69, 0.33}});
	private static Strat_calibrate strat_cali_finalMatch_TeamB = new Strat_calibrate(false, 0.96, new double[][] {{0.76, 0.2, 0.93, 0.5},{0.42, 0.32, 0.92, 0.54}});
	
	protected Strat_calibrate(boolean isTeamA, double pi_b, double[][] pi_h) {
		super(isTeamA, pi_b, pi_h);
	}
	
	
	
	public static Strat_calibrate getInstanceTeamA(){
		centralFieldP1 = Field.A22;
		centralFieldP2 = Field.A23;
		return strat_cali_finalMatch_TeamA;
	}
	
	public static Strat_calibrate getInstanceTeamB(){
		centralFieldP1 = Field.B22;
		centralFieldP2 = Field.B23;
		return strat_cali_finalMatch_TeamB;
	}
	
	@Override
	public TeamAction servingRule(State s) {
		// zufaellig einen Aufschlag auswaehlen
		Hit h = null;
		if (isTeamA){
			Player hittingPlayer;
			if (State.START_STATES_A1.contains(s)){
				// Spieler A1 schlägt
				hittingPlayer = Game.getInstance().getTeamA().getPlayer1();
			}else{
				// Spieler A2 schlägt
				hittingPlayer = Game.getInstance().getTeamA().getPlayer1();
			}
			
			double r = MainSim.countRandomCalls();
			if (r < hittingPlayer.prob_SF_LAST_ROW){
				Field f = Field.chooseRandomField(Field.LAST_ROW_B);
				h = new Hit(HitTechnique.S_F, f);
			}
			if (hittingPlayer.prob_SF_LAST_ROW <= r && r < hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW){
				Field f = Field.chooseRandomField(Field.MIDDLE_ROW_B);
				h = new Hit(HitTechnique.S_F, f);
			}
			if (hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW <= r 
					&& r < hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW+hittingPlayer.prob_SJ_LAST_ROW){
				Field f = Field.chooseRandomField(Field.LAST_ROW_B);
				h = new Hit(HitTechnique.S_J, f);
			}
			if (hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW+hittingPlayer.prob_SJ_LAST_ROW <= r 
					&& r < hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW+hittingPlayer.prob_SJ_LAST_ROW+hittingPlayer.prob_SJ_MIDDLE_ROW){
				Field f = Field.chooseRandomField(Field.MIDDLE_ROW_B);
				h = new Hit(HitTechnique.S_J, f);
			}
			
		}else{
			Player hittingPlayer;
			if (State.START_STATES_B1.contains(s)){
				// Spieler B1 schlägt
				hittingPlayer = Game.getInstance().getTeamA().getPlayer1();
			}else{
				// Spieler B2 schlägt
				hittingPlayer = Game.getInstance().getTeamA().getPlayer1();
			}
			
			double r = MainSim.countRandomCalls();
			if (r < hittingPlayer.prob_SF_LAST_ROW){
				Field f = Field.chooseRandomField(Field.LAST_ROW_A);
				h = new Hit(HitTechnique.S_F, f);
			}
			if (hittingPlayer.prob_SF_LAST_ROW <= r && r < hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW){
				Field f = Field.chooseRandomField(Field.MIDDLE_ROW_A);
				h = new Hit(HitTechnique.S_F, f);
			}
			if (hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW <= r 
					&& r < hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW+hittingPlayer.prob_SJ_LAST_ROW){
				Field f = Field.chooseRandomField(Field.LAST_ROW_A);
				h = new Hit(HitTechnique.S_J, f);
			}
			if (hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW+hittingPlayer.prob_SJ_LAST_ROW <= r 
					&& r < hittingPlayer.prob_SF_LAST_ROW+hittingPlayer.prob_SF_MIDDLE_ROW+hittingPlayer.prob_SJ_LAST_ROW+hittingPlayer.prob_SJ_MIDDLE_ROW){
				Field f = Field.chooseRandomField(Field.MIDDLE_ROW_A);
				h = new Hit(HitTechnique.S_J, f);
			}
		}

		// ab hier genauso wie bei BASIC Strategy
		Move moveServer;
		if (h.isHitWithJump()){
			moveServer = Move.m_s;
		}else{
			if (Arrays.asList(Field.OUT_A).contains(fP1)){
				moveServer = fP1.moveTowardsField(getCentralFieldOfOtherHalf(fP2));
			}else{
				moveServer = fP2.moveTowardsField(getCentralFieldOfOtherHalf(fP1));
			}
		}
		
		if (Arrays.asList(Field.OUT_A).contains(fP1) || Arrays.asList(Field.OUT_B).contains(fP1))
			return new TeamAction(new PlayerAction(h,moveServer), new PlayerAction(Hit.nohit, Move.stay));
		else
			return new TeamAction(new PlayerAction(Hit.nohit, Move.stay), new PlayerAction(h,moveServer));
	}

	@Override
	public TeamAction attackingRule(State s){
		Player hittingPlayer;
		if (isTeamA){
			if(fP1==fBall && s.getLastContact() != Game.getInstance().getTeamA().getPlayer1()){
				hittingPlayer = Game.getInstance().getTeamA().getPlayer1();
				return  new TeamAction(hittingPlayer.chooseAttackAfterCalibrationValues(), PlayerAction.doNothing);
			}
			if(fP2==fBall && s.getLastContact() != Game.getInstance().getTeamA().getPlayer2()){
				hittingPlayer = Game.getInstance().getTeamA().getPlayer2();
				return  new TeamAction(PlayerAction.doNothing, hittingPlayer.chooseAttackAfterCalibrationValues());
			}
		}else{
			if(fP1==fBall && s.getLastContact() != Game.getInstance().getTeamB().getPlayer1()){
				hittingPlayer = Game.getInstance().getTeamB().getPlayer1();
				return  new TeamAction(hittingPlayer.chooseAttackAfterCalibrationValues(), PlayerAction.doNothing);
			}
			if(fP2==fBall && s.getLastContact() != Game.getInstance().getTeamB().getPlayer2()){
				hittingPlayer = Game.getInstance().getTeamB().getPlayer2();
				return  new TeamAction(PlayerAction.doNothing, hittingPlayer.chooseAttackAfterCalibrationValues());
			}
		}
	
		if (isTeamA){
			return Strat_BASIC_BASIC.getInstanceTeamA().getTeamAction(s);
		}else{
			return Strat_BASIC_BASIC.getInstanceTeamB().getTeamAction(s);
		}
	}
	
	public String toString(){
		if (isTeamA)
			return "Strategie calibrated Team A";
		else 
			return "Strategie calibrated Team B";
	}
	
	public String toStringShort(){
			return "calibrated Strat";
	}
	

}
