package de.ubt.wm.sb.probs;

import de.ubt.wm.sb.model.Field;
import de.ubt.wm.sb.model.HitTechnique;
import de.ubt.wm.sb.sim.MainSim;

public class Prob_Attack extends Prob_Hit{
	
	private Field targetField;
	private Field playerField;
	
	public static int l_attack_succ = 3, l_attack_fault = 2, l_attack_dev = 3;
	
	public Prob_Attack(HitTechnique tech, int numberOfObservations, Prob_Hit pred, double succProb, double faultProb,
			Field targetField, Field playerField) {
		super(tech, numberOfObservations, pred, succProb, faultProb);
		if (MainSim.devFromRealMatch && numberOfObservations > 0){
			double newDevProb = Math.min(1, 2*(1-succProb-faultProb));
			double newSuccProb = Math.max(0, succProb-newDevProb/2);
			this.setAllThreeProbs(newSuccProb, faultProb);
		}	
		if (MainSim.modAttacks && numberOfObservations > 0){
//			if(Arrays.asList(Field.BORDER_LEFT_RIGHT_A).contains(targetField) || Arrays.asList(Field.BORDER_LEFT_RIGHT_B).contains(targetField)){
				this.weightOriginalProbs(l_attack_succ, l_attack_fault, l_attack_dev);
//			}
		}
		this.targetField = targetField;
		this.playerField = playerField;
	}

	public Field getTargetField() {
		return targetField;
	}

	public void setTargetField(Field targetField) {
		this.targetField = targetField;
	}

	public Field getPlayerField() {
		return playerField;
	}

	public void setPlayerField(Field playerField) {
		this.playerField = playerField;
	}

	public String toString(){
		return super.getTech() + "^" + targetField + "_" + playerField + "=[" +  super.getNumberOfObservations() + ", " + super.getSuccProb() + ", " + super.getFaultProb() + ", " + super.getNeighbourProb() + "]";
	}
	
	public String printName(){
		return super.getTech() + "^" + targetField + "_" + playerField;
	}
}
