package de.ubt.wm.sb.probs;

import de.ubt.wm.sb.model.BlockTechnique;

public class Prob_Block {

	private BlockTechnique tech;
	
	private int numberOfObservations;
	
	private double directPointProb;
	private double overNetNoFaultProb;
	private double faultProb;
	private double missesBallProb;
	
	public Prob_Block(BlockTechnique tech, int number, double directPointProb, double overNetNoFaultProb, double faultProb){
		this.tech = tech;
		this.numberOfObservations = number;
		if (directPointProb < -0.1 || overNetNoFaultProb < -0.1 || faultProb < -0.1){
			this.directPointProb = -1;
			this.overNetNoFaultProb = -1;
			this.faultProb = -1;
			this.missesBallProb = -1;
		}
		else{
			this.directPointProb = directPointProb;
			this.overNetNoFaultProb = overNetNoFaultProb;
			this.faultProb = faultProb;
			this.missesBallProb = 1 - directPointProb - overNetNoFaultProb - faultProb;
		}
	}
	
	public Prob_Block(Prob_Block prob_Block){
		this.tech = prob_Block.tech;
		
		if (prob_Block.directPointProb < -0.1 || prob_Block.overNetNoFaultProb < -0.1 || prob_Block.faultProb < -0.1){
			this.directPointProb = -1;
			this.overNetNoFaultProb = -1;
			this.faultProb = -1;
			this.missesBallProb = -1;
		}
		else{
			this.directPointProb = prob_Block.directPointProb;
			this.overNetNoFaultProb = prob_Block.overNetNoFaultProb;
			this.faultProb = prob_Block.faultProb;
			this.missesBallProb = 1 - directPointProb - overNetNoFaultProb - faultProb;
		}
	}
	
	@Override
	public String toString() {
		return tech + "=[" + numberOfObservations + ", " + directPointProb + ", " + overNetNoFaultProb + ", " + faultProb + ", " + missesBallProb + "]";
	}
	
	public String toStringLatexFormat(){
		return "Block & $b$ & $" + numberOfObservations + "$ & $" + String.format("%.2f", directPointProb)
		+ "$ & $" + String.format("%.2f",overNetNoFaultProb) 
		+ "$ & $" + String.format("%.2f",faultProb) 
		+ "$ & $" + String.format("%.2f",missesBallProb) + "$";
	}

	public BlockTechnique getTech() {
		return tech;
	}

	public double getDirectPointProb() {
		return directPointProb;
	}

	public double getOverNetNoFaultProb() {
		return overNetNoFaultProb;
	}

	public double getFaultProb() {
		return faultProb;
	}

	public double getMissesBallProb() {
		return missesBallProb;
	}
	
	public String printName() {
		return tech.toString();
	}
}
