package de.ubt.wm.sb.sim;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Random;

import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.model.strategy.RealStrat;
import de.ubt.wm.sb.model.strategy.Strategy;
import jxl.read.biff.BiffException;

public class Diss_Ch5 {
	
	public static double[] real_sprobs_final_A; // p_serve, pquer_serve, p_field, pquer_field
	public static double[] real_sprobs_final_B; // q_serve, qquer_serve, q_field, qquer_field
	static {
		String[] sprobsFiles = new String[]{"data/GER/final/GER_final_gdata_GER_final_sdata.sprobs", "data/BRA/final/BRA_final_gdata_BRA_final_sdata.sprobs"};
		for (int team = 0; team<=1; team++){
			String csvFile = sprobsFiles[team];
			BufferedReader br = null;
	        String line = "";
	        String cvsSplitBy = ";";
	        ArrayList<String[]> sprobs = new ArrayList<String[]>();
			try {
			    br = new BufferedReader(new FileReader(csvFile));
			    while ((line = br.readLine()) != null) {
			        // use cvsSplitBy as separator
			        String[] myline = line.split(cvsSplitBy);
			        if(myline!=null && myline.length>0){
			        	sprobs.add(myline);
			        }
			    }
			} catch(FileNotFoundException e){
				e.printStackTrace();
			} catch(IOException e){
				e.printStackTrace();
			} finally {
			    if (br != null) {
			        try {
			            br.close();
			        } catch (IOException e) {
			            e.printStackTrace();
			        }
			    }
			}
			
			// sprobs durchgehen
			int totNum_Service = 0;
			int totNum_Service_Point = 0;
			int totNum_Service_GoOn = 0;
			int totNum_Service_Fault = 0;
			int totNum_Field = 0;
			int totNum_Field_Point = 0;
			int totNum_Field_GoOn = 0;
			int totNum_Field_Fault = 0;
			for (int i = 0; i<sprobs.size(); i++){
				if (sprobs.get(i)[0].contains("sMDPData_result:")){
					String[] sMDPsequence = sprobs.get(i+2)[0].split("}");
					for (int j=0; j<sMDPsequence.length; j++){
						String[] anAttack;
						if (sMDPsequence[j].length()>10){
							if (j==0){
								anAttack = sMDPsequence[j].replace("{", "").replace("}", "").replace("[", "").replace("]", "").trim().split(",");
							}else{
								// das Komma am Anfang wegnehmen, wenn es sich nicht um die erste Zeile handelt
								anAttack = sMDPsequence[j].replace("{", "").replace("}", "").replace("[", "").replace("]", "").substring(1).trim().split(",");				
							}
	//						System.out.println(Arrays.toString(anAttack));
							if (anAttack.length>1){
								if (anAttack[0].contains("Field")){
									totNum_Field++;
									if (anAttack[2].contains("Point")) totNum_Field_Point++;
									if (anAttack[2].contains("GoOn")) totNum_Field_GoOn++;
									if (anAttack[2].contains("Fault")) totNum_Field_Fault++;
								}
								if (anAttack[0].contains("Service")){
									totNum_Service++;
									if (anAttack[2].contains("Point")) totNum_Service_Point++;
									if (anAttack[2].contains("GoOn")) totNum_Service_GoOn++;
									if (anAttack[2].contains("Fault")) totNum_Service_Fault++;						
								}	
							}
						}
					}
				}
			}
			
			if (totNum_Service != totNum_Service_Point + totNum_Service_GoOn + totNum_Service_Fault){
				System.err.println("Problems while reading sprobs for realized Probs, total numbers do not match!");
			}
			if (totNum_Field != totNum_Field_Point + totNum_Field_GoOn + totNum_Field_Fault){
				System.err.println("Problems while reading sprobs for realized Probs, total numbers do not match!");
			}
			double p_serve = totNum_Service_Point*1.0/totNum_Service*1.0;
			double pquer_serve = totNum_Service_Fault*1.0/totNum_Service*1.0;
			double p_field = totNum_Field_Point*1.0/totNum_Field*1.0;
			double pquer_field = totNum_Field_Fault*1.0/totNum_Field*1.0;
//			System.out.println(totNum_Service + " " 
//					+ String.format("%.2f", p_serve*100) + "\\% " + String.format("%.2f", pquer_serve*100)+ "\\%");
//			System.out.println(totNum_Field + " " 
//					+ String.format("%.2f", p_field*100) + "\\% " + String.format("%.2f", pquer_field*100)+ "\\%");
			
			if (csvFile.contains("GER")){
				real_sprobs_final_A = new double[]{p_serve, pquer_serve, p_field, pquer_field};
			}
			if (csvFile.contains("BRA")){
				real_sprobs_final_B = new double[]{p_serve, pquer_serve, p_field, pquer_field};
			}
		}
	
	}
	
	public static final String[][] skillDataFiles = new String[][] {
		{ "data/GER/allMatchesExceptFinal/GER_allMatchesExceptFinal.gprobs.csv",
			"data/BRA/allMatchesExceptFinal/BRA_allMatchesExceptFinal.gprobs.csv"},
		{ "data/GER/allMatches/GER_allMatches.gprobs.csv",
			"data/BRA/allMatches/BRA_allMatches.gprobs.csv" },
		{ "data/GER/final/GER_final.gprobs.csv",
		  "data/BRA/final/BRA_final.gprobs.csv"}
	};
	
	public static String[] skillDescription = new String[skillDataFiles.length];
	static{
		for (int i=0; i<skillDataFiles.length; i++){
			if (skillDataFiles[i][0].contains("final") && skillDataFiles[i][1].contains("final")){
				skillDescription[i] = "finalMatch";
			}
			if (skillDataFiles[i][0].contains("allMatchesExceptFinal") && skillDataFiles[i][1].contains("allMatchesExceptFinal")){
				skillDescription[i] = "allMatchesExceptFinal";
			}
			if (skillDataFiles[i][0].contains("allMatches.") && skillDataFiles[i][1].contains("allMatches.")){
				skillDescription[i] = "allMatches";
			}
			if (skillDescription[i].length()==0){
				System.err.println("Skill description can not be detected from filename");
			}
		}
	}
	
	/**
	 * one simulation for validation, that exact the same values can be used later
	 */
	public static HashMap<String, HashMap<String, HashMap<String, HashMap<String, double[]>>>> validationProbs = new HashMap<String, HashMap<String, HashMap<String, HashMap<String, double[]>>>>();
	public static double[][] allMatchesExcept = new double[2][4];
	public static double[][] allMatches = new double[2][4];
	public static double[][] finalM = new double[2][4];

	public static void calculateValidationProbs(){
		// function should return the exact the same values for fixed seed
		// is called from different places therefore we need to reset the seed to get exact values
		MainSim.r = new Random(MainSim.l);
		
		double[][] serveProbs = new double[3][4];
		double[][] fieldProbs = new double[3][4];
		for (int i=0; i<skillDataFiles.length; i++)
		{
			Game.getInstance().initGameFromEvalCSV("Germany", "Brink", "Reckerman", skillDataFiles[i][0], Strategy.cali_finalMatch_TeamA_read,
					"Brasilien", "Alison", "Emanuel", skillDataFiles[i][1], Strategy.cali_finalMatch_TeamB_read);
			SimulationManager sim_allMatchesExceptFinal = MainSim.startSim(500, false, 100, false, null, skillDescription[i]);
//			System.out.println("counter: " + MainSim.calls);
			
//			sim_allMatchesExceptFinal.writeResultsToFile("calibrationRun_"+skillDescription[i]);
			
			serveProbs[i][0] = sim_allMatchesExceptFinal.getServeP();
			serveProbs[i][1] = sim_allMatchesExceptFinal.getServePOverline();
			serveProbs[i][2] = sim_allMatchesExceptFinal.getServeQ();
			serveProbs[i][3] = sim_allMatchesExceptFinal.getServeQOverline();
			
			fieldProbs[i][0] = sim_allMatchesExceptFinal.getfAP();
			fieldProbs[i][1] = sim_allMatchesExceptFinal.getfAPOverline();
			fieldProbs[i][2] = sim_allMatchesExceptFinal.getfAQ();
			fieldProbs[i][3] = sim_allMatchesExceptFinal.getfAQOverline();
		}
		
		allMatchesExcept = new double[2][4];
		allMatches = new double[2][4];
		finalM = new double[2][4];
		for (int i = 0; i < skillDescription.length; i++){
			if (skillDescription[i].contains("final")){
				finalM[0] = serveProbs[i];
				finalM[1] = fieldProbs[i];
			}
			if (skillDescription[i].contains("MatchesExcept")){
				allMatchesExcept[0] = serveProbs[i];
				allMatchesExcept[1] = fieldProbs[i];
			}
			if (skillDescription[i].contains("allMatches") && !skillDescription[i].contains("Except")){
				allMatches[0] = serveProbs[i];
				allMatches[1] = fieldProbs[i];
			}
		}
		
		validationProbs.put("final",  new HashMap<String, HashMap<String, HashMap<String, double[]>>>());
		validationProbs.put("prefinal", new HashMap<String, HashMap<String, HashMap<String, double[]>>>());
		for (String setting : validationProbs.keySet()){
			validationProbs.get(setting).put("GER", new HashMap<String, HashMap<String, double[]>>());
			validationProbs.get(setting).put("BRA", new HashMap<String, HashMap<String, double[]>>());
		}
		for (String setting : validationProbs.keySet()){
			for (String team : validationProbs.get(setting).keySet()){
				validationProbs.get(setting).get(team).put("serve", new HashMap<String, double[]>());
				validationProbs.get(setting).get(team).put("field", new HashMap<String, double[]>());
			}
		}
		validationProbs.get("final").get("GER").get("serve").put("cali", new double[]{finalM[0][0],finalM[0][1]});
		validationProbs.get("final").get("GER").get("field").put("cali", new double[]{finalM[1][0],finalM[1][1]});
		validationProbs.get("final").get("BRA").get("serve").put("cali", new double[]{finalM[0][2],finalM[0][3]});
		validationProbs.get("final").get("BRA").get("field").put("cali", new double[]{finalM[1][2],finalM[1][3]});
		
		validationProbs.get("prefinal").get("GER").get("serve").put("cali", new double[]{allMatchesExcept[0][0],allMatchesExcept[0][1]});
		validationProbs.get("prefinal").get("GER").get("field").put("cali", new double[]{allMatchesExcept[1][0],allMatchesExcept[1][1]});
		validationProbs.get("prefinal").get("BRA").get("serve").put("cali", new double[]{allMatchesExcept[0][2],allMatchesExcept[0][3]});
		validationProbs.get("prefinal").get("BRA").get("field").put("cali", new double[]{allMatchesExcept[1][2],allMatchesExcept[1][3]});
		
	}
	
	public static void main(String[] args) throws BiffException, IOException {
		MainSim.r = new Random(MainSim.l);
		System.out.println("Seed: " + MainSim.l);
		// fuer die Ausgabe, dass Dezimalzahlen mit Punkt getrennt werden
		Locale.setDefault(Locale.US);

		System.out.println("------------------------------------------------");
		System.out.println("loaded Strategies from *.gdata.csv files:");
		System.out.println(Strategy.cali_allMatchesExceptFinal_TeamA_read);
		System.out.println(Strategy.cali_allMatchesExceptFinal_TeamB_read);
		System.out.println(Strategy.cali_allMatches_TeamA_read);
		System.out.println(Strategy.cali_allMatches_TeamB_read);
		System.out.println(Strategy.cali_finalMatch_TeamA_read);
		System.out.println(Strategy.cali_finalMatch_TeamB_read);
		System.out.println("------------------------------------------------");
		System.out.println("real direct point Probs of final:");
		String s = "Team A: [p^serve, pquer^serve, p^field, pquer^field] = ";
		s+= "[";
		for (double d : real_sprobs_final_A){
			s+= String.format("%.2f", d*100) + "\\%, ";
		}
		s=(String) s.subSequence(0, s.length()-2);
		s+= "]";
		System.out.println(s);
		s = "Team B: [q^serve, qquer^serve, q^field, qquer^field] = ";
		s+= "[";
		for (double d : real_sprobs_final_B){
			s+= String.format("%.2f", d*100) + "\\%, ";
		}
		s=(String) s.subSequence(0, s.length()-2);
		s+= "]";
		System.out.println(s);
		System.out.println("------------------------------------------------");
		System.out.println("Detected skill description: " + Arrays.toString(skillDescription));
		System.out.println("------------------------------------------------");
		
		/**
		 * Routines for Diss
		 */
		printSkillEstimates();
		printTable10Validation();
		
		
	}

	/**
	 * Evaluates Benchmark Question with sProbs from gMDP simulation
	 * @return an estimation of the sMDP probailities for the strategies of the benchmarkquestion; input for table 11
	 * 
	 * Note to myself: function does the same as directEstimatedsMDP Excel Sheet does with output of recommendationTable Function,
	 * results are the same (has been checked 09.04.18)
	 */
	public static Map<String, HashMap<String, HashMap<String, HashMap<String, double[]>>>> Table5_4_FirstStep() {
		MainSim.r = new Random(MainSim.l);
		System.out.println("------------------------------------------------");
		System.out.println("Simulation of gMDP for estimating sProbs (preparation Table 5_4)");
		System.out.println("------------------------------------------------");
		// simulated sProbs will be saved in HashMap -> sMDP calculation in MPC_TableRuns
		Map<String, HashMap<String, HashMap<String, HashMap<String, double[]>>>> simulatedSProbs = new HashMap<String, HashMap<String, HashMap<String, HashMap<String, double[]>>>>();
		simulatedSProbs.put("final", new HashMap<String, HashMap<String, HashMap<String, double[]>>>());
		simulatedSProbs.put("prefinal", new HashMap<String, HashMap<String, HashMap<String, double[]>>>());
		for (String k : simulatedSProbs.keySet()){
			simulatedSProbs.get(k).put("GER", new HashMap<String,HashMap<String, double[]>>());
			simulatedSProbs.get(k).put("BRA", new HashMap<String,HashMap<String, double[]>>());
		}
		for (String setting : simulatedSProbs.keySet()){
			for (String team : simulatedSProbs.get(setting).keySet()){
				simulatedSProbs.get(setting).get(team).put("serve", new HashMap<String, double[]>());
				simulatedSProbs.get(setting).get(team).put("field", new HashMap<String, double[]>());
			}
		}
		for (String setting : simulatedSProbs.keySet()){
			for (String team : simulatedSProbs.get(setting).keySet()){
				for (String sit : simulatedSProbs.get(setting).get(team).keySet()){
					simulatedSProbs.get(setting).get(team).get(sit).put("risky", new double[2]);
					simulatedSProbs.get(setting).get(team).get(sit).put("safe", new double[2]);
					simulatedSProbs.get(setting).get(team).get(sit).put("cali", new double[2]);
				}
			}
		}
		
		// classification of strategies according to benchmark question
		List<Strategy> riskyServesA = Arrays.asList(
				Strategy.prefinalRiskyA,
				Strategy.prefinalRiskySafeA,
				Strategy.finalRiskyA,
				Strategy.finalRiskySafeA);
		List<Strategy> safeServesA = Arrays.asList(
				Strategy.prefinalSafeA,
				Strategy.prefinalSafeRiskyA,
				Strategy.finalSafeA,
				Strategy.finalSafeRiskyA);
		List<Strategy> riskyFieldA = Arrays.asList(
				Strategy.prefinalRiskyA,
				Strategy.prefinalSafeRiskyA,
				Strategy.finalRiskyA,
				Strategy.finalSafeRiskyA);
		List<Strategy> safeFieldA = Arrays.asList(
				Strategy.prefinalSafeA,
				Strategy.prefinalRiskySafeA,
				Strategy.finalSafeA,
				Strategy.finalRiskySafeA);
		
		List<Strategy> riskyServesB = Arrays.asList(
				Strategy.prefinalRiskyB,
				Strategy.prefinalRiskySafeB,
				Strategy.finalRiskyB,
				Strategy.finalRiskySafeB);
		List<Strategy> safeServesB = Arrays.asList(
				Strategy.prefinalSafeB,
				Strategy.prefinalSafeRiskyB,
				Strategy.finalSafeB,
				Strategy.finalSafeRiskyB);
		List<Strategy> riskyFieldB = Arrays.asList(
				Strategy.prefinalRiskyB,
				Strategy.prefinalSafeRiskyB,
				Strategy.finalRiskyB,
				Strategy.finalSafeRiskyB);
		List<Strategy> safeFieldB = Arrays.asList(
				Strategy.prefinalSafeB,
				Strategy.prefinalRiskySafeB,
				Strategy.finalSafeB,
				Strategy.finalRiskySafeB);
		
		Map<String, HashMap<String, HashMap<String, HashMap<String, ArrayList<double[]>>>>> simSProbs_runs = new HashMap<String, HashMap<String, HashMap<String, HashMap<String, ArrayList<double[]>>>>>();
		simSProbs_runs.put("final", new HashMap<String, HashMap<String, HashMap<String, ArrayList<double[]>>>>());
		simSProbs_runs.put("prefinal", new HashMap<String, HashMap<String, HashMap<String, ArrayList<double[]>>>>());
		for (String k : simSProbs_runs.keySet()){
			simSProbs_runs.get(k).put("GER", new HashMap<String,HashMap<String, ArrayList<double[]>>>());
			simSProbs_runs.get(k).put("BRA", new HashMap<String,HashMap<String, ArrayList<double[]>>>());
		}
		for (String setting : simSProbs_runs.keySet()){
			for (String team : simSProbs_runs.get(setting).keySet()){
				simSProbs_runs.get(setting).get(team).put("serve", new HashMap<String, ArrayList<double[]>>());
				simSProbs_runs.get(setting).get(team).put("field", new HashMap<String, ArrayList<double[]>>());
			}
		}
		for (String setting : simSProbs_runs.keySet()){
			for (String team : simSProbs_runs.get(setting).keySet()){
				for (String sit : simSProbs_runs.get(setting).get(team).keySet()){
					simSProbs_runs.get(setting).get(team).get(sit).put("risky", new ArrayList<double[]>());
					simSProbs_runs.get(setting).get(team).get(sit).put("safe", new ArrayList<double[]>());
					simSProbs_runs.get(setting).get(team).get(sit).put("cali", new ArrayList<double[]>());
				}
			}
		}
		/**
		 * PREFINAL
		 */
		// set of strategies that will be simulated, will be middled at the end, variance is small
		List<Strategy> normalStratsA = Arrays.asList(
				Strategy.prefinalRiskyA,
				Strategy.prefinalRiskySafeA,
				Strategy.prefinalSafeRiskyA,
				Strategy.prefinalSafeA,
				Strategy.cali_allMatchesExceptFinal_TeamA_read,
				Strategy.cali_finalMatch_TeamA_read);
		
		List<Strategy> normalStratsB = Arrays.asList(
				Strategy.prefinalRiskyB,
				Strategy.prefinalRiskySafeB,
				Strategy.prefinalSafeRiskyB,
				Strategy.prefinalSafeB,
				Strategy.cali_allMatchesExceptFinal_TeamB_read,
				Strategy.cali_finalMatch_TeamB_read);
		
		String setting = "prefinal";
		int i = 0;
		for (RealStrat stratTeamA : normalStratsA) {
			for (RealStrat stratTeamB : normalStratsB) {
				{
					Game.getInstance().initGameFromEvalCSV("Germany", "Brink", "Reckerman",skillDataFiles[i][0], stratTeamA,
							"Brasilien", "Alison", "Emanuel", skillDataFiles[i][1], stratTeamB);

					SimulationManager simManager = MainSim.startSim(500, false, 100, false, null, skillDescription[i]);
					
					// Einordnung wo das Simulationergebnis gespeichert werden soll
					// Team A
					if (riskyServesA.contains(stratTeamA)){
						simSProbs_runs.get(setting).get("GER").get("serve").get("risky").add(new double[]{simManager.getServeP(),simManager.getServePOverline()});
					}
					if (riskyFieldA.contains(stratTeamA)){
						simSProbs_runs.get(setting).get("GER").get("field").get("risky").add(new double[]{simManager.getfAP(),simManager.getfAPOverline()});
					}
					if (safeServesA.contains(stratTeamA)){
						simSProbs_runs.get(setting).get("GER").get("serve").get("safe").add(new double[]{simManager.getServeP(),simManager.getServePOverline()});
					}
					if (safeFieldA.contains(stratTeamA)){
						simSProbs_runs.get(setting).get("GER").get("field").get("safe").add(new double[]{simManager.getfAP(),simManager.getfAPOverline()});
					}
					if (stratTeamA == Strategy.cali_allMatchesExceptFinal_TeamA_read){
						simSProbs_runs.get(setting).get("GER").get("serve").get("cali").add(new double[]{simManager.getServeP(),simManager.getServePOverline()});
						simSProbs_runs.get(setting).get("GER").get("field").get("cali").add(new double[]{simManager.getfAP(),simManager.getfAPOverline()});
					}
					// Team B
					if (riskyServesB.contains(stratTeamB)){
						simSProbs_runs.get(setting).get("BRA").get("serve").get("risky").add(new double[]{simManager.getServeQ(),simManager.getServeQOverline()});
					}
					if (riskyFieldB.contains(stratTeamB)){
						simSProbs_runs.get(setting).get("BRA").get("field").get("risky").add(new double[]{simManager.getfAQ(),simManager.getfAQOverline()});
					}
					if (safeServesB.contains(stratTeamB)){
						simSProbs_runs.get(setting).get("BRA").get("serve").get("safe").add(new double[]{simManager.getServeQ(),simManager.getServeQOverline()});
					}
					if (safeFieldB.contains(stratTeamB)){
						simSProbs_runs.get(setting).get("BRA").get("field").get("safe").add(new double[]{simManager.getfAQ(),simManager.getfAQOverline()});
					}
					if (stratTeamB == Strategy.cali_allMatchesExceptFinal_TeamB_read){
						simSProbs_runs.get(setting).get("BRA").get("serve").get("cali").add(new double[]{simManager.getServeQ(),simManager.getServeQOverline()});
						simSProbs_runs.get(setting).get("BRA").get("field").get("cali").add(new double[]{simManager.getfAQ(),simManager.getfAQOverline()});
					}
				}
			}
		}
		
		
		/**
		 * FINAL
		 */
		normalStratsA = Arrays.asList(
				Strategy.finalRiskyA,
				Strategy.finalRiskySafeA,
				Strategy.finalSafeRiskyA,
				Strategy.finalSafeA,
				Strategy.cali_allMatchesExceptFinal_TeamA_read,
				Strategy.cali_finalMatch_TeamA_read);
		
		normalStratsB = Arrays.asList(
				Strategy.finalRiskyB,
				Strategy.finalRiskySafeB,
				Strategy.finalSafeRiskyB,
				Strategy.finalSafeB,
				Strategy.cali_allMatchesExceptFinal_TeamB_read,
				Strategy.cali_finalMatch_TeamB_read);
		
		
		i = 2;
		setting = "final";
		for (RealStrat stratTeamA : normalStratsA) {
			for (RealStrat stratTeamB : normalStratsB) {
				{
					Game.getInstance().initGameFromEvalCSV("Germany", "Brink", "Reckerman",skillDataFiles[i][0], stratTeamA,
							"Brasilien", "Alison", "Emanuel", skillDataFiles[i][1], stratTeamB);

					SimulationManager simManager = MainSim.startSim(500, false, 100, false, null, skillDescription[i]);
					
					// Einordnung wo das Simulationergebnis gespeichert werden soll
					// Team A
					if (riskyServesA.contains(stratTeamA)){
						simSProbs_runs.get(setting).get("GER").get("serve").get("risky").add(new double[]{simManager.getServeP(),simManager.getServePOverline()});
					}
					if (riskyFieldA.contains(stratTeamA)){
						simSProbs_runs.get(setting).get("GER").get("field").get("risky").add(new double[]{simManager.getfAP(),simManager.getfAPOverline()});
					}
					if (safeServesA.contains(stratTeamA)){
						simSProbs_runs.get(setting).get("GER").get("serve").get("safe").add(new double[]{simManager.getServeP(),simManager.getServePOverline()});
					}
					if (safeFieldA.contains(stratTeamA)){
						simSProbs_runs.get(setting).get("GER").get("field").get("safe").add(new double[]{simManager.getfAP(),simManager.getfAPOverline()});
					}
					if (stratTeamA == Strategy.cali_finalMatch_TeamA_read){
						simSProbs_runs.get(setting).get("GER").get("serve").get("cali").add(new double[]{simManager.getServeP(),simManager.getServePOverline()});
						simSProbs_runs.get(setting).get("GER").get("field").get("cali").add(new double[]{simManager.getfAP(),simManager.getfAPOverline()});
					}
					// Team B
					if (riskyServesB.contains(stratTeamB)){
						simSProbs_runs.get(setting).get("BRA").get("serve").get("risky").add(new double[]{simManager.getServeQ(),simManager.getServeQOverline()});
					}
					if (riskyFieldB.contains(stratTeamB)){
						simSProbs_runs.get(setting).get("BRA").get("field").get("risky").add(new double[]{simManager.getfAQ(),simManager.getfAQOverline()});
					}
					if (safeServesB.contains(stratTeamB)){
						simSProbs_runs.get(setting).get("BRA").get("serve").get("safe").add(new double[]{simManager.getServeQ(),simManager.getServeQOverline()});
					}
					if (safeFieldB.contains(stratTeamB)){
						simSProbs_runs.get(setting).get("BRA").get("field").get("safe").add(new double[]{simManager.getfAQ(),simManager.getfAQOverline()});
					}
					if (stratTeamB == Strategy.cali_finalMatch_TeamB_read){
						simSProbs_runs.get(setting).get("BRA").get("serve").get("cali").add(new double[]{simManager.getServeQ(),simManager.getServeQOverline()});
						simSProbs_runs.get(setting).get("BRA").get("field").get("cali").add(new double[]{simManager.getfAQ(),simManager.getfAQOverline()});
					}
				}
			}
		}
		
		
		// calculate mean value from different simulation runs
		for (String setting1 : simSProbs_runs.keySet()){
			for (String team : simSProbs_runs.get(setting1).keySet()){
				for (String sit : simSProbs_runs.get(setting1).get(team).keySet()){
					for (String strat: simSProbs_runs.get(setting1).get(team).get(sit).keySet()){
						
						double sumP = 0;
						double sumPOverline = 0;
						for (int k = 0; k < simSProbs_runs.get(setting1).get(team).get(sit).get(strat).size(); k++){
							sumP += simSProbs_runs.get(setting1).get(team).get(sit).get(strat).get(k)[0];
							sumPOverline += simSProbs_runs.get(setting1).get(team).get(sit).get(strat).get(k)[1];
						}
						double P = sumP/simSProbs_runs.get(setting1).get(team).get(sit).get(strat).size();
						double POverline = sumPOverline/simSProbs_runs.get(setting1).get(team).get(sit).get(strat).size();
						simulatedSProbs.get(setting1).get(team).get(sit).get(strat)[0] = P;
						simulatedSProbs.get(setting1).get(team).get(sit).get(strat)[1] = POverline;
						
						// for comparison with excel table results
//						System.out.println(setting1 + " " + team + " " + sit + " " + strat + ": " + String.format("%.0f", P*100) + "%, " + String.format("%.0f",POverline*100)+ "%");
					}
				}
			}
		}
		
		return simulatedSProbs;
		
	}
	
	private static void printSkillEstimates() {
		for (int i = 0; i <skillDataFiles.length; i++){
			if (skillDescription[i]=="allMatchesExceptFinal"){
				Game.getInstance().initGameFromEvalCSV("Germany", "Brink", "Reckerman",skillDataFiles[i][0], Strategy.cali_allMatchesExceptFinal_TeamA_read,
						"Brasilien", "Alison", "Emanuel", skillDataFiles[i][1], Strategy.cali_allMatchesExceptFinal_TeamB_read);
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Brink for all Matches Except Final");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamA().getPlayer1().printIndProbs());
				System.out.println("------------------------------------------------\n");
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Reckermann for all Matches Except Final");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamA().getPlayer2().printIndProbs());
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Alison for all Matches Except Final");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamB().getPlayer1().printIndProbs());
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Emanuel for all Matches Except Final");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamB().getPlayer2().printIndProbs());
				System.out.println("------------------------------------------------\n");
			}
		}
		for (int i = 0; i <skillDataFiles.length; i++){
			if (skillDescription[i]=="finalMatch"){
				Game.getInstance().initGameFromEvalCSV("Germany", "Brink", "Reckerman",skillDataFiles[i][0], Strategy.cali_allMatchesExceptFinal_TeamA_read,
						"Brasilien", "Alison", "Emanuel", skillDataFiles[i][1], Strategy.cali_allMatchesExceptFinal_TeamB_read);
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Brink for final");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamA().getPlayer1().printIndProbs());
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Reckermann for final");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamA().getPlayer2().printIndProbs());
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Alison for final");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamB().getPlayer1().printIndProbs());
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Emanuel for final");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamB().getPlayer2().printIndProbs());
				System.out.println("------------------------------------------------\n");
			}
		}
		for (int i = 0; i <skillDataFiles.length; i++){
			if (skillDescription[i]=="allMatches"){
				Game.getInstance().initGameFromEvalCSV("Germany", "Brink", "Reckerman",skillDataFiles[i][0], Strategy.cali_allMatchesExceptFinal_TeamA_read,
						"Brasilien", "Alison", "Emanuel", skillDataFiles[i][1], Strategy.cali_allMatchesExceptFinal_TeamB_read);
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Brink for all matches");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamA().getPlayer1().printIndProbs());
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Reckermann all matches");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamA().getPlayer2().printIndProbs());
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Alison for all matches");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamB().getPlayer1().printIndProbs());
				System.out.println("------------------------------------------------");
				System.out.println("Input Probs Emanuel for all matches");
				System.out.println("------------------------------------------------");
				System.out.println(Game.getInstance().getTeamB().getPlayer2().printIndProbs());
				System.out.println("------------------------------------------------\n");
			}
		}
		
	}
	
	public static void printTable10Validation(){
		calculateValidationProbs();
		
		System.out.println("------------------------------------------------");
		System.out.println("Diss Table 5.3: Validation of simulated \\strategicMDP{} transition probabilities");
		System.out.println("------------------------------------------------");
		StringBuffer s = new StringBuffer();
		s.append("\\begin{table}\n"
			+"\\small\n"
			+"\\begin{center}\n"
			+"\\begin{tabular}{lcccccccc}\n"
			+"\\toprule\n"
			+"estimation method & $\\directPointProbServeA{\\emph{final}}$ & $\\faultProbServeA{\\emph{final}}$ & $\\directPointProbServeB_{\\emph{final}}$ & $\\faultProbServeB_{\\emph{final}}$ & $\\directPointProbFieldA{\\emph{final}}$ & $\\faultProbFieldA{\\emph{final}}$ & $\\directPointProbFieldB_{\\emph{final}}$ & $\\faultProbFieldB_{\\emph{final}}$ \\\\\n"
			+"\\midrule\n"
			+"realized probabilities final & $"+String.format("%.0f", real_sprobs_final_A[0]*100)+"\\%$ & $"+String.format("%.0f", real_sprobs_final_A[1]*100)+"\\%$ & $"+String.format("%.0f", real_sprobs_final_B[0]*100)+"\\%$ & $"+String.format("%.0f", real_sprobs_final_B[1]*100)+"\\%$ "
			+"& $"+String.format("%.0f", real_sprobs_final_A[2]*100)+"\\%$ & $"+String.format("%.0f", real_sprobs_final_A[3]*100)+"\\%$ & $"+String.format("%.0f", real_sprobs_final_B[2]*100)+"\\%$ & $"+String.format("%.0f", real_sprobs_final_B[3]*100)+"\\%$ \\\\\n"
			+"\\midrule\n"
			+"simulating the \\gameplayMDP{} with & & & & & & & & \\\\\n"
			+"\\midrule\n"
			+"skills of all matches except final & $"+String.format("%.0f", allMatchesExcept[0][0]*100)+"\\%$ & $"+String.format("%.0f", allMatchesExcept[0][1]*100)+"\\%$ & $"+String.format("%.0f", allMatchesExcept[0][2]*100)+"\\%$ & $"+String.format("%.0f", allMatchesExcept[0][3]*100)+"\\%$ "
			+"& $"+String.format("%.0f", allMatchesExcept[1][0]*100)+"\\%$ & $"+String.format("%.0f", allMatchesExcept[1][1]*100)+"\\%$ & $"+String.format("%.0f", allMatchesExcept[1][2]*100)+"\\%$ & $"+String.format("%.0f", allMatchesExcept[1][3]*100)+"\\%$ \\\\\n"
			+"skills of all matches & $"+String.format("%.0f", allMatches[0][0]*100)+"\\%$ & $"+String.format("%.0f", allMatches[0][1]*100)+"\\%$ & $"+String.format("%.0f", allMatches[0][2]*100)+"\\%$ & $"+String.format("%.0f", allMatches[0][3]*100)+"\\%$ "
			+"& $"+String.format("%.0f", allMatches[1][0]*100)+"\\%$ & $"+String.format("%.0f", allMatches[1][1]*100)+"\\%$ & $"+String.format("%.0f", allMatches[1][2]*100)+"\\%$ & $"+String.format("%.0f", allMatches[1][3]*100)+"\\%$ \\\\\n"
			+"skills of final only & $"+String.format("%.0f", finalM[0][0]*100)+"\\%$ & $"+String.format("%.0f", finalM[0][1]*100)+"\\%$ & $"+String.format("%.0f", finalM[0][2]*100)+"\\%$ & $"+String.format("%.0f", finalM[0][3]*100)+"\\%$ "
			+"& $"+String.format("%.0f", finalM[1][0]*100)+"\\%$ & $"+String.format("%.0f", finalM[1][1]*100)+"\\%$ & $"+String.format("%.0f", finalM[1][2]*100)+"\\%$ & $"+String.format("%.0f", finalM[1][3]*100)+"\\%$ \\\\\n"
			+"\\bottomrule\n"
			+"\\end{tabular}\n"
			+"\\end{center}\n"
			+"\\caption{Validation of simulated \\strategicMDP{} transition probabilities}\n"
			+"\\label{tab:g-MDP-validation}\n"
			+"\\end{table}");
		
		System.out.println(s.toString());
		System.out.println("------------------------------------------------\n");

		
	}
	
}
