package de.ubt.wm.sb.probs;

import de.ubt.wm.sb.model.Technique;

public class Prob_Hit {

	private Technique tech;
	
	private double succProb;
	private double faultProb;
	private double neighbourProb;
	private final double fracSuccFault;
	private final double fracSuccNeighbour;
	private final double fracFaultNeighbour;
	
	public Prob_Hit(Technique tech, double succProb, double faultProb) {
		super();
		this.tech = tech;
		this.succProb = succProb;
		this.faultProb = faultProb;
		this.neighbourProb = 1-succProb-faultProb;
		this.fracSuccFault = succProb/faultProb; 
		this.fracFaultNeighbour = faultProb/neighbourProb;
		this.fracSuccNeighbour = succProb/neighbourProb;
	}
	
	public Prob_Hit(Prob_Hit prob){
		this.tech = prob.tech;
		this.succProb = prob.succProb;
		this.faultProb = prob.faultProb;
		this.neighbourProb = prob.neighbourProb;
		this.fracSuccFault = prob.fracSuccFault;
		this.fracFaultNeighbour = prob.fracSuccNeighbour;
		this.fracSuccNeighbour = prob.fracSuccNeighbour;
	}

	@Override
	public String toString() {
		return tech + "=[" + succProb + ", " + faultProb + ", " + neighbourProb + "]";
	}
	
	public Technique getTech() {
		return tech;
	}

	public void setTech(Technique tech) {
		this.tech = tech;
	}

	public double getSuccProb() {
		return succProb;
	}
	
	public void setAllThreeProbs(double succProb, double faultProb){
		this.succProb = succProb;
		this.faultProb = faultProb;
		this.neighbourProb = 1-succProb-faultProb;		
	}
	
	public void setSuccProb(double succProb) {
		this.succProb = succProb;
		this.neighbourProb = (1 - succProb)/(1+this.fracFaultNeighbour);
		this.faultProb = 1 - this.succProb - this.neighbourProb;		
	}

	public double getFaultProb() {
		return faultProb;
	}

	public void setFaultProb(double faultProb) {
		this.faultProb = faultProb;
		this.neighbourProb = (1-faultProb)/(1+this.fracSuccNeighbour);
		this.succProb = 1 - this.faultProb - this.neighbourProb;
	}

	public double getNeighbourProb() {
		return neighbourProb;
	}

	public void setNeighbourProb(double neighbourProb) {
		this.neighbourProb = neighbourProb;
		this.faultProb = (1-neighbourProb)/(1+this.fracSuccFault);
		this.succProb = 1 - this.neighbourProb - this.faultProb;
	}

	public double getFracSuccFault() {
		return fracSuccFault;
	}

	public double getFracSuccNeighbour() {
		return fracSuccNeighbour;
	}

	public double getFracFaultNeighbour() {
		return fracFaultNeighbour;
	}

	public String printName() {
		return tech.toString();
	}
}

