package de.ubt.wm.sb.sim;

import de.ubt.wm.sb.model.RealStrat;
import de.ubt.wm.sb.probs.ProbType;

public class ResultSim {

	private RealStrat stratTeamA;
	private RealStrat stratTeamB;
	
	private double p_serve;
	private double pOverline_serve;
	private double q_serve;
	private double qOverline_serve;
	
	private double p_fA;
	private double pOverline_fA;
	private double q_fA;
	private double qOverline_fA;
	
	private double parameterizedValue;
	private ProbType probType;
	private int	numberOfSets;

	public ResultSim(RealStrat stratTeamA, RealStrat stratTeamB,
			double p_serve, double pOverline_serve, double q_serve,
			double qOverline_serve, double p_fA, double pOverline_fA,
			double q_fA, double qOverline_fA, double paramVal, ProbType probType, int numberOfSets) {
		super();
		this.stratTeamA = stratTeamA;
		this.stratTeamB = stratTeamB;
		this.p_serve = p_serve;
		this.pOverline_serve = pOverline_serve;
		this.q_serve = q_serve;
		this.qOverline_serve = qOverline_serve;
		this.p_fA = p_fA;
		this.pOverline_fA = pOverline_fA;
		this.q_fA = q_fA;
		this.qOverline_fA = qOverline_fA;
		this.parameterizedValue = paramVal;
		this.probType = probType;
		this.numberOfSets = numberOfSets;
	}

	public ResultSim() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("Result " + probType + "\n"
			   + "Strategie TeamA: " + stratTeamA.toString() + "\n" 
			   + "Strategie TeamB: " + stratTeamB.toString() + "\n");
		s.append("modProb\tp_serve pO_serve q_serve aO_serve \tp_fA   pO_fA  q_fA   qO_fA\n");
		s.append(String.format("%1.4f \t%1.4f  %1.4f   %1.4f  %1.4f   \t%1.4f %1.4f %1.4f %1.4f \n ------------------------", parameterizedValue, p_serve, pOverline_serve, q_serve, qOverline_serve, p_fA, pOverline_fA, q_fA, qOverline_fA));
		return s.toString();
	}

	public RealStrat getStratTeamA() {
		return stratTeamA;
	}

	public void setStratTeamA(RealStrat stratTeamA) {
		this.stratTeamA = stratTeamA;
	}

	public RealStrat getStratTeamB() {
		return stratTeamB;
	}

	public void setStratTeamB(RealStrat stratTeamB) {
		this.stratTeamB = stratTeamB;
	}

	public double getP_serve() {
		return p_serve;
	}

	public void setP_serve(double p_serve) {
		this.p_serve = p_serve;
	}

	public double getpOverline_serve() {
		return pOverline_serve;
	}

	public void setpOverline_serve(double pOverline_serve) {
		this.pOverline_serve = pOverline_serve;
	}

	public double getQ_serve() {
		return q_serve;
	}

	public void setQ_serve(double q_serve) {
		this.q_serve = q_serve;
	}

	public double getqOverline_serve() {
		return qOverline_serve;
	}

	public void setqOverline_serve(double qOverline_serve) {
		this.qOverline_serve = qOverline_serve;
	}

	public double getP_fA() {
		return p_fA;
	}

	public void setP_fA(double p_fA) {
		this.p_fA = p_fA;
	}

	public double getpOverline_fA() {
		return pOverline_fA;
	}

	public void setpOverline_fA(double pOverline_fA) {
		this.pOverline_fA = pOverline_fA;
	}

	public double getQ_fA() {
		return q_fA;
	}

	public void setQ_fA(double q_fA) {
		this.q_fA = q_fA;
	}

	public double getqOverline_fA() {
		return qOverline_fA;
	}

	public void setqOverline_fA(double qOverline_fA) {
		this.qOverline_fA = qOverline_fA;
	}

	public int getNumberOfSets() {
		return numberOfSets;
	}

	public void setNumberOfSets(int numberOfSets) {
		this.numberOfSets = numberOfSets;
	}

	public ProbType getProbType() {
		return probType;
	}

	public void setProbType(ProbType probType) {
		this.probType = probType;
	}

	public double getParameterizedValue() {
		return parameterizedValue;
	}

	public void setParameterizedValue(double parameterizedValue) {
		this.parameterizedValue = parameterizedValue;
	}	
}
