//////////////////////////////////////
// author: Susanne Hoffmeister
// created: 11.10.17, modified for Diss/MPC Paper
//////////////////////////////////////
CHECKRESULT=false;
if (process.argv.length != 5){
	console.log('########################################\n'
			   +'# estimate s-MDP Probs from gdata and sdata files\n'
			   +'# must be called with 3 argument: \n'
			   +'# \t <team> gMDP.gdata sMDP.sdata\n'
			   +'# <team> states if the team is collected as team A or B in the sdata.\n'
			   +'########################################\n');
	console.log('# Example runs for Diss:');
	console.log(  '\t node evaluate-sdata.js A  BRA/final/BRA_final.gdata BRA/final/BRA_final.sdata\n'
				+ '\t node evaluate-sdata.js A  BRA/final/BRA_final.gdata BRA/final/BRA_final.sdata\n'
				+ '\t node evaluate-sdata.js A  BRA/allMatches/BRA_allMatches.gdata BRA/allMatches/BRA_allMatches.sdata\n'
				+ '\t node evaluate-sdata.js A  BRA/allMatchesExceptFinal/BRA_allMatchesExceptFinal.gdata BRA/allMatchesExceptFinal/BRA_allMatchesExceptFinal.sdata\n'
				+ '\t node evaluate-sdata.js A  GER/final/GER_final.gdata GER/final/GER_final.sdata\n'
				+ '\t node evaluate-sdata.js A  GER/allMatches/GER_allMatches.gdata GER/allMatches/GER_allMatches.sdata\n'
				+ '\t node evaluate-sdata.js A  GER/allMatchesExceptFinal/GER_allMatchesExceptFinal.gdata GER/allMatchesExceptFinal/GER_allMatchesExceptFinal.sdata');
	process.exit(1);
}else{
	team = process.argv[2]
	var gMDPData_path = process.argv[3];
	var sMDPData_path = process.argv[4];
	var header  = 'This file was automatically generated by evaluate-gdata.js\n'
				+ '------------------------------------\n'
				+ 'view of team ' + team + '\n'
				+ 'gMDP data of team: ' + gMDPData_path + "\n"
				+ 'sMDP match data: ' + sMDPData_path + "\n"
				+ '------------------------------------\n';
	console.log(header);
}

var oppTeam ="";
if (team == "A"){
	oppTeam ="B";
}else{
	if (team == "B"){
		oppTeam = "A";
	}else{
		console.log("Team is not known! must be A or B!");
		process.exit(1);
	}
}

var gMDPData_filename = gMDPData_path.substring(gMDPData_path.lastIndexOf("/")+1,gMDPData_path.lastIndexOf("."))
var sMDPData_filename = sMDPData_path.substring(sMDPData_path.lastIndexOf("/")+1,sMDPData_path.lastIndexOf("."))

var fs = require('fs');
var output_file = "temp_result/" + Date.now() + gMDPData_filename + "_gdata_" + sMDPData_filename + "_sdata.sprobs";
fs.writeFileSync(output_file, header);
// fs.writeFile(output_file, header, function(err) {
//     if(err) {
//         return console.log(err);
//     }

//     console.log("The file with header was created and saved!");
// });


//-------------------
// einlesen
//-------------------

var gMDPData = fs.readFileSync(gMDPData_path).toString().split('\n');
console.log(sMDPData_path)
var sMDPDataRallies = JSON.parse(fs.readFileSync(sMDPData_path).toString());

var gMDPDataJSON = new Array();
for (i=0;i<gMDPData.length;i++){
	var entryhelper = gMDPData[i].split(';');
	var e = {
		tech: entryhelper[6],
		res: entryhelper[12],
		b_target_x: entryhelper[10],
		b_target_y: entryhelper[11]
	};
	gMDPDataJSON.push(e);
}

//-----------------------
// Ausgabe des gMDPs als kurze Version damit leichter zu lesen
//-----------------------
// var output_GMDP = "";
// for (i=0;i<gMDPDataJSON.length;i++){
// 	var e = gMDPDataJSON[i];
// 	output_GMDP+=e.tech+":"+e.res+":"+e.b_target_x+":"+e.b_target_y+"\n";
// }

// fs.writeFile("temp_result/" + gMDPData_filename +"_SHORT.gdata", output_GMDP, function(err){
// 	if(err) {
//         return console.log(err);
//     }

//     console.log("The gMDP gdata SHORT war written to File!");
// })
//-----------------------


var sMDPData = new Array();
for (i=0;i<sMDPDataRallies.length;i++){
	var entryhelper = sMDPDataRallies[i].rally.split("-");
	for (j=0;j<entryhelper.length;j++){
		sMDPData.push(entryhelper[j]);
	}
}

// console.log(sMDPData);
//-----------------------
// gMDP Angriffsschlaege, die in risky/safe Fallen
//-----------------------
var stratAttacks = { service:
						{
							risky: {serviceNumbers: new Array(),
									fANumbers: new Array(),
									directPoints: 0,
									faults: 0,
									goOn: 0},
						  	safe: {serviceNumbers: new Array(),
						  			fANumbers: new Array(),
									directPoints: 0,
									faults: 0,
									goOn: 0},
						},
					 fieldAttack:
					 	{
					 		risky: {serviceNumbers: new Array(),
					 				fANumbers: new Array(),
									directPoints: 0,
									faults: 0,
									goOn: 0},
					 		safe: {serviceNumbers: new Array(),
					 				fANumbers: new Array(),
									directPoints: 0,
									faults: 0,
									goOn: 0},
					 	}
					};

//----------------------
// gMDP Data können nicht evaluiert werden
// nur Angriffe können identifiziert werden
//----------------------
var gMDPData_result = new Array();
var gMDPData_rally = new Array();
var gMDPData_attack = {};
var nService_gMDP = 0;
var nFieldAttack_gMDP = 0;
var lastEntryWasAttack = false;
var helper_i = -1; // Achtung muss -1 sein, falls gesamtes Spiel mit Aufschlag beginnt
for (i=0; i<gMDPDataJSON.length;i++){
	var currentEntry = gMDPDataJSON[i];

	var outType = identifyAttack(currentEntry, gMDPDataJSON[i-1],lastEntryWasAttack);

	if (outType){
		// ein neuer Service startet
		if (outType=="Service"){
			if (gMDPData_rally.length>0){
				gMDPData_result.push(gMDPData_rally);
				gMDPData_rally = new Array();
			}
			gMDPData_attack = {};
			gMDPData_attack.type = "Service";
			gMDPData_attack.number = ++nService_gMDP;
			gMDPData_rally.push(gMDPData_attack);
			nFieldAttack_gMDP=0;
			lastEntryWasAttack=true;
		}
		// ein Feldangriff startet
		if (outType=="Field"){
			gMDPData_attack = {};
			gMDPData_attack.type = "Field";
			gMDPData_attack.number = ++nFieldAttack_gMDP;
			gMDPData_rally.push(gMDPData_attack);
			lastEntryWasAttack=true;
		}
	}else{
		// kein Angriff wurde gezaehlt, outType=undefined
		lastEntryWasAttack=false;
	}

	// einzelne Schlaege (S,F) nach Strategie auswerten
	var stratOutput = checkIfAttackBelongsToStrat(currentEntry);
	if(stratOutput){
		if (stratOutput.type=="Service"){
			if (stratOutput.a=="risky"){
				stratAttacks.service.risky.serviceNumbers.push(nService_gMDP);
				stratAttacks.service.risky.fANumbers.push(0);
			}
			if (stratOutput.a=="safe"){
				stratAttacks.service.safe.serviceNumbers.push(nService_gMDP);
				stratAttacks.service.safe.fANumbers.push(0);
			}
		}
		if (stratOutput.type=="Field"){
			if (stratOutput.a=="risky"){
				if (i==20){
					console.log("ACHTUNG: Skip it bei BRAsilien da FSM kein Angriff");
				}else{
				stratAttacks.fieldAttack.risky.serviceNumbers.push(nService_gMDP);
				stratAttacks.fieldAttack.risky.fANumbers.push(nFieldAttack_gMDP);
			}
			}
			if (stratOutput.a=="safe"){
				stratAttacks.fieldAttack.safe.serviceNumbers.push(nService_gMDP);
				stratAttacks.fieldAttack.safe.fANumbers.push(nFieldAttack_gMDP);
			}
		}
	}
}
// am Schluss letzten Rally einfügen
gMDPData_result.push(gMDPData_rally);

console.log("\n-------------found hits that belong to strat---------");
for (sit in stratAttacks){
	for (a in stratAttacks[sit]){
		stratAttacks[sit][a].totalObs = stratAttacks[sit][a].serviceNumbers.length;
		console.log(sit + " " + a +": " + stratAttacks[sit][a].totalObs);
	}
}
console.log("-----------------------------------------------------\n");


//----------------------
// sMDP Data -> Point GoOn Fault
//----------------------
var sMDPData_result = new Array();
var sMDPData_rally = new Array();
var sMDPData_attack = {};
var nService = 0;
var nFieldAttack = 0;
var flag=false;
while (sMDPData.length>0){
	var nextEntry=sMDPData.shift();
	if (flag && nextEntry==("Point"+team)){
		sMDPData_attack.result = "Point";
		sMDPData_rally.push(sMDPData_attack);
		flag = false;
	}
	if (flag && nextEntry==("Point"+oppTeam)){
		sMDPData_attack.result = "Fault";
		sMDPData_rally.push(sMDPData_attack);
		flag = false;
	}
	if (flag && (nextEntry==("Field"+oppTeam) || nextEntry==("Field"+team))){
		sMDPData_attack.result = "GoOn";
		sMDPData_rally.push(sMDPData_attack);
		flag = false;
	}
	if (nextEntry==("Serve"+team)){
		if (sMDPData_rally.length>0){
			sMDPData_result.push(sMDPData_rally);
			sMDPData_rally = new Array();
		}
		sMDPData_attack = {};
		sMDPData_attack.type = "Service";
		sMDPData_attack.number = ++nService;
		nFieldAttack=0;
		flag = true;
	}
	if (nextEntry==("Field"+team)){
		sMDPData_attack = {};
		sMDPData_attack.type = "Field";
		sMDPData_attack.number = ++nFieldAttack;
		flag = true;
	}
}
// am Schluss letzten Rally einfügen
sMDPData_result.push(sMDPData_rally);


//----------------------
// Überprüfung
//----------------------

checkResults(sMDPData_result, gMDPData_result);

//----------------------
// Ausgabe der Angriffabfolgen
//----------------------

var output_content = "";
output_content+="-------------------------------------\n";
output_content+="gMDPData_result length: " + gMDPData_result.length + "\n";
output_content+="sMDPData_result length: " + sMDPData_result.length + "\n";
output_content+="-------------------------------------\n";
output_content+="sMDPData_result:\n";
output_content+="-------------------------------------\n";
output_content+=JSON.stringify(sMDPData_result);
output_content+="\n-------------------------------------\n";
output_content+="gMDPData_result:\n";
output_content+="-------------------------------------\n";
output_content+=JSON.stringify(gMDPData_result);

// console.log(output_content);

fs.appendFile(output_file, output_content, function(err){
	if(err) {
        return console.log(err);
    }

    console.log("The Rally content was saved to file!");
})

//----------------------
// Auswertung der strategischen Schlaege
// hier müssen jetzt sMDP results genommen werden
//----------------------
// nur wenn Synchronisation perfekt werden die Schlaeg ausgewertet
if (CHECKRESULT){
console.log("\n---------Auswertung der strategischen Schlaege---------");

	for (sit in stratAttacks){
		for (a in stratAttacks[sit]){
			for (i=0; i<stratAttacks[sit][a].serviceNumbers.length; i++){
				var serviceNumber = stratAttacks[sit][a].serviceNumbers[i];
				var fANumber = stratAttacks[sit][a].fANumbers[i];
				// nachschauen ob die gMDP Sequenz mit Service beginnt
				if (sMDPData_result[0][0].type == "Field"){
					// i. Service ist im Array an iter Stelle
					serviceNumber;
				}else{
					// i. Service ist im Array an i-1ter Stelle
					serviceNumber--;
				}
				// falls Feldangriff aus erstem Rally ohne Service von Team A, gibt es keinen Service und fA muss -1 genommen werden
				if (sMDPData_result[0][0].type == "Field" && serviceNumber==0){
					fANumber--;
				}
				// console.log(serviceNumber + " " + fANumber);
				if (sMDPData_result[serviceNumber][fANumber].result=="GoOn"){
					stratAttacks[sit][a].goOn++;
				}
				if (sMDPData_result[serviceNumber][fANumber].result=="Fault"){
					stratAttacks[sit][a].faults++;
				}
				if (sMDPData_result[serviceNumber][fANumber].result=="Point"){
					stratAttacks[sit][a].directPoints++;
				}
			}
		}
	}

	console.log(stratAttacks);
	var output_result="\n----------------------------------------------\n";
	output_result+=JSON.stringify(stratAttacks);
	output_result+="\n----------------------------------------------\n";
	output_result+=printResult(stratAttacks);

	fs.appendFile(output_file, output_result, function(err){
		if(err) {
	        return console.log(err);
	    }

	    console.log("The Strategy evaluation content was saved to file!");
	})
}

//----------------------------------------
// Helper Functions
//----------------------------------------
function isServe(tech){
	if (tech == "SJF" || tech == "SF" || tech == "SJ")
		return true;
	else
		return false;
}

function isFieldAttack(tech){
	if (tech == "FSM" || tech == "FSH" || tech == "FP")
		return true;
	else
		return false;
}

function isBlock(tech){
	if (tech == "bl" || tech == "bd" || tech == "b")
		return true;
	else
		return false;
}



function checkResults(sMDPData_result, gMDPData_result){
	var nService_sMDP=sMDPData_result.length;
	var nService_gMDP=gMDPData_result.length;

	console.log("\n---------Check Results-------------");
	console.log("sMDP Services: " + nService_sMDP);
	console.log("gMDP Services: " + nService_gMDP);
	console.log("Note: printed value equals #Service+1,\n if match started with service of opponent Team");
	console.log("------------------------------------");
	if (nService_sMDP!=nService_gMDP){
		console.log("Fehler! Anzahl der Services stimmt nicht überein!");
		// process.exit(1);
	}

	var flag = false;
	for (i=0; i<sMDPData_result.length;i++){
		if(!gMDPData_result[i]){
			console.log("------------------------------------");
			console.log("Unterschied in Service Anzahl führt dazu, dass ein Rally in gMDP nicht existiert");
		}else{
			if (sMDPData_result[i].length!=gMDPData_result[i].length){
				console.log("------------------------------------");
				console.log("Unterschied in Rally Laengen bei Service Nr: " + (i+1));
				console.log("sMDP:");
				console.log(sMDPData_result[i])
				console.log("gMDP:");
				console.log(gMDPData_result[i])
				console.log("------------------------------------");
				flag = true;
			}else{
				for (j=0; j<sMDPData_result[i].length;j++){
					if (sMDPData_result[i][j].type!=gMDPData_result[i][j].type){
						console.log("------------------------------------");
						console.log("Unterschied im Angriffstyp! Service Nr: " + (i+1) + ", Anfriff Nr.:" + (j+1));
						console.log("sMDP Type:");
						console.log(sMDPData_result[i][j].type)
						console.log("gMDP Type:");
						console.log(gMDPData_result[i][j].type)
						console.log("------------------------------------");
						flag = true;
					}
				}
			}
		}
	}
	if (!flag){
		console.log("...no faults! sMDP and gMDP match!");
	}
	console.log("--------------Ende Check------------\n");

	CHECKRESULT=!flag;
}


//---------------------------------------------
// Function aus estimateSMDPProbsByStrat
// modifiziert, sodass sie P;F;G zurückgibt, sonst aber gleiche Bedingungen
//---------------------------------------------
function identifyAttack(currentEntry, prevEntry, lastEntryWasAttack){
	// console.log(currentEntry)
	if (isServe(currentEntry.tech)){
		return "Service";
	}
	if (isFieldAttack(currentEntry.tech) && !lastEntryWasAttack 
		&& prevEntry.tech!="s"
		&& !isBlock(prevEntry.tech) // FieldAttack ist nur Abstauber
		&& !isFieldAttack(prevEntry.tech) // FieldAttack ist nur Abstauber
		){
		return "Field";
	}
	if (currentEntry.tech=="s"){
		return "Field";
	}
	if (prevEntry){
		if (currentEntry.tech=="d" && !lastEntryWasAttack && (prevEntry.tech=="r" || prevEntry.tech=="d") && prevEntry.res!= "fault"){
			return "Field";
		}
	}
}
function evalHitInMatchData(i,h,attackType){
	var isServiceBool = false;
	var isFieldAttackBool = false;
	if (attackType=="Service"){
		isServiceBool = true;
	}
	if (attackType=="Field"){
		isFieldAttackBool = true;
	}

	var output = {};

	var t = 0;
	// schaue bis zum ersten Mal nicht mehr das Team in Ballbesitz ist
	while(h[i+t].team==team){
		t++;
	}
	output.t = t;

	if (isServiceBool){
		if (h[i+t].team=="Point"+team // direkter Punkt für schlagendes Team
			|| (h[i+t].team==oppTeam && h[i+t+1].team=="Point"+team) // gegnerisches Team versucht noch anzunehmen, scheitert aber
			|| (h[i+t].team==oppTeam && h[i+t+1].team==oppTeam && h[i+t].tech=="r" && h[i+t+1].tech=="r"
				&& h[i+t+2].team=="Point"+team) // beide Spieler im gegnerischen Team versuchen anzunehmen, scheitern aber
			){
			output.res = "P";
			return output;
		}
		if (h[i+t].team=="Point"+oppTeam // direkter Fehler
			|| (h[i+t].team==oppTeam && h[i+t+1].team=="Point"+oppTeam) // versucht selbst noch anzunehmen, scheitert aber
			){
			output.res = "F";
			return output;
		}
		if (h[i+t].team==oppTeam && h[i+t+1].team==oppTeam // ein gegnerischer Angriff startet
			|| (h[i+t].team==oppTeam && h[i+t+1].team==team) // reception with deviation, eigener Angriff startet
			){
			output.res = "G";
			return output;
		}
	}


	if (isFieldAttackBool){
		if (h[i+t].team=="Point"+team // direkter Punkt für schlagendes Team
			|| (h[i+t].team==oppTeam && h[i+t+1].team=="Point"+team) // gegnerisches Team versucht noch anzunehmen, scheitert aber
			|| (h[i+t].team==oppTeam && isBlock(h[i+t].tech) && h[i+t+1].team==oppTeam && h[i+t+2].team=="Point"+team) // // gegnerisches Team blockt erst versucht selbst noch anzunehmen, scheitert aber
			){
			output.res = "P";
			return output;
		}
		if (h[i+t].team=="Point"+oppTeam // direkter Fehler
			|| (h[i+t].team==oppTeam && h[i+t+1].team=="Point"+oppTeam) // versucht selbst noch anzunehmen, scheitert aber
			|| (h[i+t].team==oppTeam && isBlock(h[i+t].tech) && h[i+t+2].team=="Point"+oppTeam) // erst Block, dann dann annahme versuch, dann scheitern
			|| (isFieldAttack(h[i+t].tech) && h[i+t+1].team==team && h[i+t+1].res=="fault" && h[i+t+2].team=="Point"+oppTeam) // gegnerisches Team schmettert sofort zurück -> Fehler
			){
			output.res = "F";
			return output;
		}
		if (h[i+t].team==oppTeam && h[i+t+1].team==oppTeam // ein gegnerischer Angriff startet
			|| (h[i+t].team==oppTeam && h[i+t+1].team==team) // reception with deviation, eigener Angriff startet
			|| (h[i+t].team==oppTeam && h[i+t].tech=="bl" && h[i+t].res=="okBlock" && h[i+t+1].team==team && h[i+t+2].team==team) // Ball wird geblockt und ein neuer Angriff auf eigener Seite startet
			){
			output.res = "G";
			return output;
		}
	}

	var action_warning="";
	action_warning+=("-------" + "\n");
	action_warning+=("Aktion konnte nicht evaluiert werden: " + "\n");
	action_warning+=(h[i]);
	action_warning+=(h[i+1]);
	action_warning+=(h[i+2]);
	action_warning+=("-------"+ "\n");
	console.log(action_warning);
}


//--------------------------
// find risky/safe Services/Attack
//_-------------------------

function checkIfAttackBelongsToStrat(hit){
		// risky services
		if (hit.tech=="SJ"){
			// countSJ++;
			if (hit.b_target_y <= 0.125 || hit.b_target_y >= 0.875){
				return {type: "Service", a: "risky"}
			}
		}
		// safe services
		if (hit.tech=="SJF" || hit.tech=="SF"){
			// countSFSJF++;
			if (hit.b_target_y >= 0.125 && hit.b_target_y <= 0.875){
				return {type: "Service", a: "safe"}
			}
		}
		// risky fieldAttacks
		if (hit.tech=="FSM"){
			// countFSM++;
			if (hit.b_target_y <= 0.125 || hit.b_target_y >= 0.875){
				return {type: "Field", a: "risky"}
			}
		}
		// safe fieldAttacks
		if (hit.tech=="FP"){
			// countFP++;
			if (hit.b_target_y >= 0.125 && hit.b_target_y <= 0.875){
				return {type: "Field", a: "safe"}
			}
		}
}


function printResult(result){
	var output_printResult="";
	output_printResult+=("\n--------------results-------------\n");
	for (act in result[sit]){
		for (sit in result){
			output_printResult+="strat: " + act + "; situation: " + sit + "; totalObs: " + result[sit][act].totalObs + ";\n"
			output_printResult+=("p:\t" + roundToPercent(result[sit][act].directPoints/result[sit][act].totalObs) +"\%;\t"
								+ "pquer:\t" + roundToPercent(result[sit][act].faults/result[sit][act].totalObs) +"\%;\n");
		}
		output_printResult+="\n";
	}
	output_printResult+=("\n--------------actual played mixture-------------\n");
	output_printResult+="strat: cali; situation: service; totalObs: " + (result.service.risky.totalObs+result.service.safe.totalObs) + ";\n"
	output_printResult+=("p:\t" + roundToPercent((result.service.risky.directPoints+result.service.safe.directPoints)/(result.service.risky.totalObs+result.service.safe.totalObs)) +"\%;\t"
						+ "pquer:\t" + roundToPercent((result.service.risky.faults+result.service.safe.faults)/(result.service.risky.totalObs+result.service.safe.totalObs)) +"\%;\n");
	output_printResult+="strat: cali; situation: fieldAttack; totalObs: " + (result.fieldAttack.risky.totalObs+result.fieldAttack.safe.totalObs) + ";\n"
	output_printResult+=("p:\t" + roundToPercent((result.fieldAttack.risky.directPoints+result.fieldAttack.safe.directPoints)/(result.fieldAttack.risky.totalObs+result.fieldAttack.safe.totalObs)) +"\%;\t"
						+ "pquer:\t" + roundToPercent((result.fieldAttack.risky.faults+result.fieldAttack.safe.faults)/(result.fieldAttack.risky.totalObs+result.fieldAttack.safe.totalObs)) +"\%;\n");

	output_printResult+=("\n--------------for latex table-------------\n");
	output_printResult+=(result.service.risky.totalObs + " & "
		+ roundToPercent(result.service.risky.directPoints/result.service.risky.totalObs) + "\\% & "
		+ roundToPercent(result.service.risky.faults/result.service.risky.totalObs)+ "\\% \t"
		+ result.fieldAttack.risky.totalObs + " & "
		+ roundToPercent(result.fieldAttack.risky.directPoints/result.fieldAttack.risky.totalObs) + "\\% & "
		+ roundToPercent(result.fieldAttack.risky.faults/result.fieldAttack.risky.totalObs)+ "\\%\n");
	output_printResult+=(result.service.safe.totalObs + " & "
		+ roundToPercent(result.service.safe.directPoints/result.service.safe.totalObs) + "\\% & "
		+ roundToPercent(result.service.safe.faults/result.service.safe.totalObs)+ "\\% \t\t"
		+ result.fieldAttack.safe.totalObs + " & "
		+ roundToPercent(result.fieldAttack.safe.directPoints/result.fieldAttack.safe.totalObs) + "\\% & "
		+ roundToPercent(result.fieldAttack.safe.faults/result.fieldAttack.safe.totalObs)+ "\\%\n\n");
	console.log(output_printResult);
	return output_printResult;
}

function roundToPercent(d){
	return Math.round(d * 10000)/100;
}
















